        program amavg
c
        character infil*40,outfil*40
c
c GET DATA FILE NAME AND OPEN INPUT FILE
c
       type *,'Enter USER EXIT SPEED file to read: '
       accept '(a)',infil
       open(unit=13,file=infil,status='old',readonly,
     :    form='formatted')
c
c CHOOSE TIME INTERVAL OVER WHICH TO AVERAGE
c
       type 3
3      format(' Enter averaging interval in minutes: ')
       accept *,avint
c
c OPEN OUTPUT FILE BASED ON TIME INTERVAL CHOSEN
c
       write(outfil,4) int(avint)
4      format('amavg',i3.3,'.dat')
       open(unit=12,file=outfil,status='new',access='direct',
     :  recordsize=150)
c
c CALL SUBROUTINE TO PROCESS DATA
c
       CALL AVGTIME(AVINT)
c
       stop
       end
c*******************************	              
       subroutine avgtime(avint)
c
c This routine called by amavg reads *.out file and averages.
c
       parameter len=128,long=50
	include 'adcp_var.include / list'
	parameter (num_byt_rec=128, num_col=4)
c
c	integer*2	num_byt_rec 
c	byte		num_col 
	integer*2	ib
	integer*2	iy
	integer*2	id
	integer*2	numbins
	integer*2	it
	integer*2	ie
	integer*2	ip
	real*4		dummy_vax_time         /0.0/
	real*4		dummy_gps_decimal_part /0.0/
	real*4		rd
	real*4		rw
	real*4		rx
	real*4		rb
	real*4		rr
	real*4		rp
	real*4		rh
	real*4		rs
	real*4		rf
	real*4		rl
	real*4		ro
	real*4		rv
	real*4		rat
	real*4		rsdt
	real*4		rah
	real*4		rsdh
	real*4		rap
	real*4		rsdp
	real*4		rar
	real*4		rsdr
	real*4		re
	real*4		rn
	real*4		rz
	logical*1	Data_Flag( 0:24 )
	real*4		vx( num_byt_rec )
	real*4		vy( num_byt_rec )
	real*4		vz( num_byt_rec )
	real*4		ve( num_byt_rec )
	real*4		amp( num_byt_rec )
	real*4		pctgd( num_byt_rec )
	integer*2	iunit
	real*4		avsw( num_byt_rec )
	real*4		rdpv( num_byt_rec, num_col )
	real*4		ramp( num_byt_rec, num_col )
	real*4		rspw( num_byt_rec, num_col )
	real*4		n3b( num_byt_rec )
	real*4		bmg( num_col )
	real*4		stdv( num_byt_rec, num_col )
	real*8		dlon(100),dlat(100)
	real*8 		dl1,dl2,dl3,dl4,dist,azf,azb
	integer*4 	itim1,itim2,dtime(100)
        character infil*40
c
       dimension u(len),v(len),uu(len),vv(len),ur(long,5),vr(long,5),
     :  x(long,5),y(long,5),nn(len),uref(5),vref(5),xpos(5),ypos(5),
     :  nref(5)
	real*4 ashdif(50000),ashtim(50000)
	real*4 uvfac/1.0/      !/1.014/
	real*4 gmisoff/0.0/       !/0.80/
	integer*4 numbin,dh_mean
	character*80 ping_file_name
c
	number_of_beams = 4
c
       tdelt=avint/1440.
       nchk=1 !int(avint*.3333)-1
       realdum=-999.9
c
       ncc=1          ! record counter for output file
       nrec=1         ! record counter for input file
c
c
c GET DATA FILE NAME AND OPEN INPUT FILE
c
       type *,'Enter USER EXIT SPEED file to read: '
       accept '(a)',infil
       open(unit=13,file=infil,status='old',readonly,
     :    form='formatted')
c
	nash=1
	do i=1,50000
	read(13,531,end=105)nen,dt,yg,xg,ug,vg,gyro,dh_mean,n_used,
     :         itim1,dl1,dl2,itim2,dl3,dl4
	if(abs(dh_mean).lt.200 .and. n_used.gt.10)then
	nash=nash+1
	ashdif(nash)=dh_mean
	ashtim(nash)=dt
	end if
	end do
c
105	nash=nash+1
	ashdif(nash)=ashdif(nash-1)
	ashtim(nash)=ashtim(nash-1)+10.
	ashdif(1)=ashdif(2)
	ashtim(1)=ashtim(2)-10.
	close(13)
c
       open(unit=13,file=infil,status='old',readonly,
     :    form='formatted')
c
c	do iunit=1,500
c
	type *,'Enter BINARY PING file name'
	read(*,'(a)')ping_file_name
c
	open(unit=11,file=ping_file_name,status='old',form='unformatted',
     :	readonly)
c
c SET VALUES BELOW TO ZERO EVERY TIME PROGRAM RETURNS TO STATEMENT 15.
c
15     do 10 j=1,len
           uu(j)=0.
           vv(j)=0.
	   nn(j)=0.
10     end do
       do 11 j=1,5
           uref(j)=0.
           vref(j)=0.
           xpos(j)=0.
           ypos(j)=0.
11     end do
c
       tavg=0.
       nc=0
	ndl=0
c
	ubarmean=0.
	vbarmean=0.
	nbar=0
c
c READ INPUT FILES
c
20	read(11,end=95)iy,VXT,id,ib,it,ie,ip,rd,rw,rx,rb,rr,rp,rh,rs,rf,rl,ro,
     :  rv,rat,rsdt,rah,rsdh,rap,rsdp,rar,rsdr,re,rn,rz,GPT,
     :  (data_flag(i),i=0,24),(vx(i),vy(i),vz(i),ve(i),amp(i),pctgd(i),
     :  i=1,ib)
c
	numbins = ib
	numbin=ib
	if(data_flag(18))read(11)(avsw(i),i=1,numbins)
	if(data_flag(19))read(11)((rdpv(i,j),i=1,numbins),j=1,4)
	if(data_flag(20))read(11)((ramp(i,j),i=1,numbins),j=1,4)
	if(data_flag(21))read(11)((rspw(i,j),i=1,numbins),j=1,4)
 	if(data_flag(22))read(11)(n3b(i),i=1,numbins)
	if(data_flag(23))read(11)(bmg(j),j=1,4)
     	if(data_flag(24))read(11)((stdv(i,j),i=1,numbins),j=1,4)
c
	   umax = -999
	   umin =  999
	   nlast = 999
c
	nb=numbin
	do k=1,nb-2               !   AGC slope check for bottom
          delagc1=amp(k+1) - amp(k)
          delagc2=amp(k+2) - amp(k)
          if(delagc1.gt.10. .or. delagc2.gt.14.)then
             nlast = k
             goto 8
          end if
        end do
c
8	nb = min(nlast,nb)	                        
c
	   do k=1,nb
	    if(pctgd(k).le.30. .or. amp(k).le.30.)then
               nlast = k-1
	       goto 103
	    end if
	   end do
c
c	READ(13,*)nen,DT,YG,XG,UG,VG,howgood
103	read(13,531)nen,dt,yg,xg,ug,vg,gyro,dh_mean,n_used,
     :         itim1,dl1,dl2,itim2,dl3,dl4
531	format(i6,3f12.5,3f8.1,2i6,2(i10,2f12.5))
c
	call enterp(dt,ashtim,ashdif,nash,2,dh_terp,ner)
c	type *,dh_mean,dh_terp
c
	ndl=ndl+1
	dtime(ndl)=itim1
	dlon(ndl)=dl2
	dlat(ndl)=dl1
	ndl=ndl+1
	dtime(ndl)=itim2
	dlon(ndl)=dl4
	dlat(ndl)=dl3
c
	ubar=0.
	vbar=0.
	nlast = min(nlast,nb)	                        
c
        gmis=gmisoff+(dh_terp+25.)/100.
c
	do k=1,nlast
c
	utemp=vx(k)*uvfac
	vtemp=vy(k)*uvfac
c
        vx(k)=utemp*cosd(gmis)+vtemp*sind(gmis)
        vy(k)=vtemp*cosd(gmis)-utemp*sind(gmis)
c
c	type 844,ghd,utemp,vtemp,fwd,cros,vx(k),vy(k),ug,vg
844	format(9f7.1)
c
	ubar=ubar+vx(k)
	vbar=vbar+vy(k)
	end do
c
	if(nlast.ne.0)then
		ubar=ubar/float(nlast)
		vbar=vbar/float(nlast)
	end if
c	type *,id+rd,nlast,ubar,vbar
c
	do k=nlast+1,ib
	vx(k)=-999.9
	vy(k)=-999.9
	pctgd(k)=0.
	end do
c
c	READ(13,*)nen,DT,YG,XG,UG,VG,howgood
c
       time=DT
       if(nc.eq.0) then
           atime=dt
           bino=2.**rw
       else
           if((time-atime).gt.tdelt) go to 50
       end if
c
c STORE NAVIGATION REFERENCE DATA INTO RESPECTIVE ARRAYS
c
       nc=nc+1
       if(abs(xg).lt.900. .and. abs(yg).lt.900. .and. 
     :    abs(vg).lt.900. .and. abs(ug).lt.900.) then    !.and.
c     :    n_used.gt.20) then
              x(nc,1)=xg  
              y(nc,1)=yg  
              ur(nc,1)=ug
              vr(nc,1)=vg
       else
              x(nc,1)=realdum
              y(nc,1)=realdum
              ur(nc,1)=realdum
              vr(nc,1)=realdum
       end if
c
c
       if(abs(xg).lt.900. .and. abs(yg).lt.900. .and.
     :    abs(re).lt.900. .and. abs(rn).lt.900. ) then
              x(nc,2)=xg 
              y(nc,2)=yg 
              ur(nc,2)=-re  
              vr(nc,2)=-rn  
       else
              x(nc,2)=realdum
              y(nc,2)=realdum
              ur(nc,2)=realdum
              vr(nc,2)=realdum
       end if

c
       do 45 j=1,ib
           if(pctgd(j).gt.30.)then
		uu(j)=uu(j)+vx(j)-ubar
           	vv(j)=vv(j)+vy(j)-vbar
           	nn(j)=nn(j)+1
	   end if
45     end do
c
       ubarmean=ubarmean+ubar
       vbarmean=vbarmean+vbar
	nbar=nbar+1
c
	oldt=time
       nrec=nrec+1
       go to 20
c
50     continue
c
       if(nc.lt.nchk) go to 15
c
c	do i=1,ndl
c	type *,dtime(i),dlat(i),dlon(i)
c	end do
c
	call geodinv(dlat(1),dlon(1),dlat(ndl),dlon(ndl),dist,azf,azb)
c
	tdif=dtime(ndl)-dtime(1)
	if(tdif.le.0.)tdif=tdif+86400.
c
	spd=(dist*100.)/tdif
	dhd=(90.-azf)+.0001
	ubg=spd*cosd(dhd)
	vbg=spd*sind(dhd)
c
	if(nbar.ne.0)then
       ubarmean = ubarmean/float(nbar)
       vbarmean = vbarmean/float(nbar)
	end if
c
	do 55 j=1,ib
           if(nn(j).ne.0)then
	     uu(j)=uu(j)/float(nn(j)) + ubarmean
             vv(j)=vv(j)/float(nn(j)) + vbarmean
	   else
	     uu(j)=realdum
	     vv(j)=realdum
	   end if
55     end do
       atime=(atime+oldt)/2.
c
       do 60 n=1,2
         nref(n)=0.
         uref(n)=0.
         vref(n)=0.
         xpos(n)=0.
         ypos(n)=0.
		ncl=0
		ssu=0.
		ssv=0.
		smu=0.
		smv=0.
         do 65 j=1,nc
           if(abs(ur(j,n)).lt.998.and.abs(vr(j,n)).lt.998.)then
		smu=smu+ur(j,n)
		smv=smv+vr(j,n)
		ssu=ssu+ur(j,n)*ur(j,n)
		ssv=ssv+vr(j,n)*vr(j,n)
		ncl=ncl+1
c	
             uref(n)=uref(n)+ur(j,n)
             vref(n)=vref(n)+vr(j,n)
             if(x(j,n).gt.0.)x(j,n)=x(j,n)-360.
	     xpos(n)=xpos(n)+x(j,n)
             ypos(n)=ypos(n)+y(j,n)
             nref(n)=nref(n)+1
           end if
65       end do
c		if(ncl.gt.1)then
c		stdu=sqrt((ssu-(smu*smu/ncl))/(ncl-1))
c		stdv=sqrt((ssv-(smv*smv/ncl))/(ncl-1))
c		smu=smu/float(ncl)
c		smv=smv/float(ncl)
c		end if
c
c		do icl=1,nc
c		type *,icl,' u dev ',abs(ur(icl,n)-smu),' std dev ',stdu
c		type *,icl,' v dev ',abs(vr(icl,n)-smv),' std dev ',stdv
c		end do
c
         if(nref(n).lt.nchk) then
            uref(n)=realdum
            vref(n)=realdum
            xpos(n)=realdum
            ypos(n)=realdum
	    nref(n)=-1
         else
            refn=float(nref(n))
            uref(n)=uref(n)/refn
            vref(n)=vref(n)/refn
            xpos(n)=xpos(n)/refn
            if(xpos(n).lt.-180.)xpos(n)=xpos(n)+360.
	    ypos(n)=ypos(n)/refn
         end if
60     end do 
c
c
c TYPE EVERY 10 RECORDS TO SCREEN.
c
	if(nref(2).ne.0)then
c		type *,atime,uref(1),uref(2),vref(1),vref(2)
	end if
       if(mod(ncc,10).eq.0) then
c         write(6,61) ncc,atime,uref(1),ubg,-ubarmean,vref(1),vbg,-vbarmean
61       format(i5,f12.5,6f8.1)
       end if
c	type *,ncc,atime,nc,nbar,numbin,ib
c
c WRITE INTO AVERAGED OUTPUT FILE
c
c	write(12'ncc) atime,(ypos(j),xpos(j),uref(j),vref(j),j=1,1),
        write(12'ncc) atime,ypos(1),xpos(1),ubg,vbg,
     :  nc,numbin,bino,(uu(ll),vv(ll),ll=1,ib)
c       type *, atime,(ypos(j),xpos(j),uref(j),vref(j),j=1,5),
c     :  nc,ib,bino,(uu(ll),vv(ll),ll=1,ib)
c
       ncc=ncc+1
c
       go to 15
c
95	type *,' end day ',iunit
c
999    type *,ncc,' Records written to output file'
       close(unit=12)
       stop
       end

	subroutine geodinv (la1,lo1,la2,lo2,dist,azf,azb)
c
c quick geodetic inverse based on NOAA NOS Tech Rep NOS 81 (J Collins)
c lat,lon are in decimal degrees with S,W negative
c dist is returned in meters, azimuths in true degrees 0-360
c
	implicit real*8 (a-m,o-z)       ! only integers are n's
c
c       a=6378206.4   !6378163.  ! alternate values
c       b=6356583.8   !6356177.  ! alternate values
	a=6378135.0   !wgs-72
	b=6356750.5   !wgs-72
c
	if(la1.eq.la2 .and. lo1.eq.lo2)then
		dist=0.
		azb=0.
		azf=0.
		return
	end if
c
	conv = 3.141592654 / 180.
	e0 = a*a - b*b          ! some eccentricities, not all of which
	e1 = e0 / (a*a)         ! are used.
	e2 = e0 / (b*b)
	e3 = e0 / (a*a + b*b)
	e4 = e0 / (a*b)
c
	lat1=la1*conv
	lon1=lo1*conv
	lat2=la2*conv
	lon2=lo2*conv
	dlon=lon2-lon1
c
	tanpsi1 =  b*b * tan(lat1) / (a*a)         ! geocentric lats
	tanpsi2 =  b*b * tan(lat2) / (a*a)
c
	psi1 = atan(tanpsi1)
	psi2 = atan(tanpsi2)
c
	azf = atan2 ( sin(dlon) ,                  !      fwd azimuth
     :        ( tanpsi2 - tanpsi1*cos(dlon) ) * cos(psi1) )
c
	azb = atan2 ( sin(-dlon) ,                 !      back azimuth
     :        ( tanpsi1 - tanpsi2*cos(-dlon) ) * cos(psi2) )
c
	theta1 = atan2(cos(azf),tanpsi1)
	theta2 = atan2(cos(azb),tanpsi2)
c
	beta0 = atan2 ( a * sqrt( tanpsi1*tanpsi1 +
     :          tanpsi2*tanpsi2 - 2.*tanpsi1*tanpsi2*
     :          cos(dlon) ) , b * sin(dlon) )
c
	bbar = b * sqrt ( 1. + e2 * cos(beta0)*cos(beta0) )
	mbar = (a*a - bbar*bbar) / (a*a + bbar*bbar)
c
	rad0 = sqrt ( .5 * (a*a+bbar*bbar) ) * ( 1. - mbar*mbar/16.)
	biga = mbar / 4. + 21.*mbar*mbar*mbar / 128.
	bigb = mbar*mbar / 64.
c
	s1=rad0*(theta1-biga*sin(2.*theta1)+bigb*sin(4.*theta1))
	s2=rad0*(theta2-biga*sin(2.*theta2)+bigb*sin(4.*theta2))
c
	dist = s1 + s2
	azf=azf/conv
	azb=azb/conv
	if(azf.lt.0.)azf=azf+360.
	if(azb.lt.0.)azb=azb+360.

	if(la1.eq.la2)then
		dist=(lo2-lo1)*cosd(la1)*110320.
	end if
c
	return
	end
c
        SUBROUTINE ENTERP(X,XT,YT,NX,NPX,Y,NERR)
        DIMENSION XT(1),YT(1)
        NERR=0
        INTER=1
        NP=NPX
        IF(NX.LT.NP) NP=NX
        IH=NP/2
        I=1
        IF(XT(I)-X)30,20,10
10        IH=0
12        NERR=1
        GO TO 70
13        NERR=2
        GO TO 70
20        INTER=2
22        Y=YT(I)
        GO TO 999
30        I=NX
        IF(XT(I)-X)13,20,40
40     N1=1
        N2=NX
45      MP=(N1+N2)/2
50      IF(XT(MP)-X)52,54,56
52      N1=MP
        GO TO 60
54      I=MP
        GO TO 20
56      N2=MP
60      IF(N2-N1.NE.1) GO TO 45
        I=MAX0(N2,IH+1)
70        K=I-IH
        N=K+NP-1
        Y=0.
        IF(N-NX)90,90,80
80        N=NX
        K=NX-NP+1
90        DO 120 J=K,N
        P=1.
        DO 110 I=K,N
        IF(I-J)100,110,100
100        P=P*(X-XT(I))/(XT(J)-XT(I))
110        CONTINUE
120        Y=Y+YT(J)*P
999      RETURN
        END

