 	real*4 xpos(5),ypos(5),uref(5),vref(5)
	real*4 utemp(128),vtemp(128),usurf(5),vsurf(5)
	real*4 uu(128,10000),vv(128,10000),uship(10000),vship(10000)
	integer*4 npos(10000),nvel(10000),ndr(10000)
	real*4 time(10000),x(10000),y(10000),us(10000,5),vs(10000,5)
	character*80 filename
	character*1 leng
c
	type *,' Enter name of averaged data file'
	accept '(a)',filename
	
	open(unit=13,file=filename,status='old',readonly,
     :     form='unformatted',access='direct')
c
	type *,'Enter start, stop records'
	accept *,nd1,nd2
c
	nrec= 0
c
	do i=nd1,nd2
c
	read(13'i,err=955)atime,(ypos(j),xpos(j),uref(j),vref(j),j=1,1),
     :  nc,numbin,bino,(utemp(ll),vtemp(ll),ll=1,numbin)
c	type *,nc,numbin,bin0
	ib=numbin
	nrec=nrec+1
c
	do j=1,1
	us(nrec,j)=uref(j)
	vs(nrec,j)=vref(j)
	end do
c
	time(nrec)=atime
	ndr(nrec)=i
c
	do j=1,ib
	uu(j,nrec)=utemp(j)
	vv(j,nrec)=vtemp(j)
	end do
c
	x(nrec)=-999.9
	y(nrec)=-999.9
	npos(nrec)=-1
	if(abs(xpos(1)).lt.900.)then
		x(nrec)=xpos(1)
		y(nrec)=ypos(1)
		npos(nrec)=1
	end if
c
	uship(nrec)=-999.9
	vship(nrec)=-999.9
	nvel(nrec)=-1
	if(abs(uref(1)).lt.900.)then
		uship(nrec)=uref(1)
		vship(nrec)=vref(1)
		nvel(nrec)=1
	end if
c
	numbin=max(numbin,ib)
c
	end do
c
955	continue
c
	leng='S'
	call str$upcase (leng,leng)
c
	type *,'Enter levels to vertically average'
	accept *,ilev1,ilev2
c
	do i=1,nrec
c
	do j=1,1
c
	nsurf=0
	usurf(j)=0
	vsurf(j)=0
c
	do k=ilev1,ilev2
	if(abs(uu(k,i)).lt.950. .and. abs(us(i,j)).lt.950.)then
		usurf(j)=usurf(j)+uu(k,i)+us(i,j)
		vsurf(j)=vsurf(j)+vv(k,i)+vs(i,j)
		nsurf=nsurf+1
	end if
	end do
c
	if(nsurf.ne.0)then
	  usurf(j)=usurf(j)/float(nsurf)
	  vsurf(j)=vsurf(j)/float(nsurf)
	else
 	  usurf(j) = -999.9
	  vsurf(j) = -999.9
	end if	
c
	end do
c
	write(18,844)ndr(i),time(i),y(i),x(i),npos(i),
     :  uship(i),vship(i),nvel(i),(usurf(j),vsurf(j),j=1,1)
844	FORMAT(I5,F10.4,2F9.3,I3,2f7.1,i3,8f7.1)
c
	END DO
c
       stop
       end            

