        program stnavg
c
	character*80 filename
	real*4 lstart(100),lstop(100),az(100),wt(100),wtsum(100)
	integer lstn(100,2),n(100,100)
	real*4 u(100,100),v(100,100),utemp(100),vtemp(100),perp(100,100)
	real*4 xstart(100),xstop(100),ystart(100),ystop(100)
	real*4 wperp(100,100),stran(100),svtran(151),zz(100)
	real*8 x1,y1,x2,y2,d12,az12,az21
c
	open(unit=10,file='pairs.dat',status='old',readonly)
c
	do i=1,100
	read(10,*,end=90)lstn(i,1),lstn(i,2),lstart(i),
     :    ystart(i),xstart(i),lstop(i),ystop(i),xstop(i)
	end do
c
90	npair=i-1
c
	do j=1,npair
	x1=xstart(j)
	x2=xstop(j)
	y1=ystart(j)
	y2=ystop(j)
	call geodinv (y1,x1,y2,x2,d12,az12,az21)
	az(j)=az12
	wt(j)=d12
	end do
c
	type *,' Enter name of averaged data file'
	accept '(a)',filename
c
	open(unit=13,file=filename,status='old',readonly,
     :     form='unformatted',access='direct')
c
	do i=1,100000
	read(13'i,err=955)atime,ypos,xpos,uref,vref,
     :  nc,ib,bino,(utemp(ll),vtemp(ll),ll=1,ib)
c
c	is it good?
c
	uvref=sqrt(uref*uref+vref*vref)

	if(uvref.lt.1300. .and. uvref.ge. 150.)then
c
c	find station pair 
c
	nstn=0
	do j=1,npair
	if(atime.ge.lstart(j) .and. atime.le.lstop(j))nstn=j
	end do
c
c	type *,xpos,xstart(nstn),xstop(nstn)
	if(abs(uref).lt.950. .and. abs(vref).lt.950. .and. 
     :          nstn.ne.0 .and. xpos.ge.xstart(nstn) .and. xpos
     :          .le. xstop(nstn))then
	nref=nref+1
	urav=urav+uref
	vrav=vrav+vref
	end if
c
	do j=1,ib
	utst=uref+utemp(j)
	vtst=vref+vtemp(j)
	if(utst.lt.500. .and. vtst.lt.500. .and. nstn.ne.0 .and.
     :     abs(uref).lt.950. .and. abs(vref).lt.950. and. 
     :     abs(utemp(j)).lt.950. .and. abs(vtemp(j)).lt.950.)then
	secdir=90-az(nstn)
	pvel=vtst*cosd(secdir)-utst*sind(secdir)
	u(nstn,j)=u(nstn,j)+utst
	v(nstn,j)=v(nstn,j)+vtst
	perp(nstn,j)=perp(nstn,j)+pvel
	n(nstn,j)=n(nstn,j)+1
	end if
	end do
c
	end if
c
	end do
c
955	type *,nref,urav/nref,vrav/nref
c
c
	open(unit=21,file='ui1.dat',status='new',form='formatted',
     :  recl=512)
	open(unit=22,file='vi1.dat',status='new',form='formatted',
     :  recl=512)
	open(unit=20,file='perp.dat',status='new',form='formatted',
     :  recl=512)
	open(unit=19,file='wperp.dat',status='new',form='formatted',
     :  recl=512)
c
	do i=1,npair
c	if(i.ne.18 .and. i.ne.30 .and. i.ne.37 .and. i.ne.38)then
c
	type 880,lstn(i,1),lstn(i,2),lstart(i),ystart(i),
     :  xstart(i),lstop(i),ystop(i),xstop(i)
	write(25,880)lstn(i,1),lstn(i,2),lstart(i),ystart(i),
     :  xstart(i),lstop(i),ystop(i),xstop(i)
880	format(2i8,6f10.4)
	do j=1,100
	if(n(i,j).ne.0)then
	  u(i,j)=u(i,j)/float(n(i,j))
	  v(i,j)=v(i,j)/float(n(i,j))
	  perp(i,j)=perp(i,j)/float(n(i,j))
	else
	  u(i,j)=-999.9
	  v(i,j)=-999.9
	end if
	end do
	write(21,810)(u(i,j),j=1,50)
	write(22,810)(v(i,j),j=1,50)
	write(20,810)(perp(i,j),j=1,50)
c	end if
c
	end do
810	format(50f8.1)
c
	do i=1,npair
	do j=1,100
	wperp(i,j)=wperp(i,j)+perp(i,j)*wt(i)
	wtsum(j)=wtsum(j)+wt(i)
	end do
	end do
c
	do i=1,npair
	do j=1,100
	wperp(i,j)=wperp(i,j)/wtsum(j)
	end do
	write(19,810)(wperp(i,j),j=1,50)
	end do
c
	do i=1,npair
	do j=2,51
	stran(j)=stran(j)+wperp(i,j-1)
	end do
	end do
	stran(1)=(stran(2)+stran(3))/2.
	do j=2,51
	zz(j)=j*8-2
	end do
	zz(1)=0.
c
c	do i=1,51
c	type *,i,zz(i),stran(i)
c	end do
c
	do i=1,151
	p0=(i-1)*2.
	call enterp(p0,zz,stran,51,2,svtran(i),ner)
	write(27,*)p0,svtran(i)
	end do
c
	stop
	end		
	subroutine geodinv (la1,lo1,la2,lo2,dist,azf,azb)
c
c quick geodetic inverse based on NOAA NOS Tech Rep NOS 81 (J Collins)
c lat,lon are in decimal degrees with S,W negative
c dist is returned in meters, azimuths in true degrees 0-360
c
	implicit real*8 (a-m,o-z)       ! only integers are n's
c
c       a=6378206.4   !6378163.  ! alternate values
c       b=6356583.8   !6356177.  ! alternate values
	a=6378135.0   !wgs-72
	b=6356750.5   !wgs-72
c
	if(la1.eq.la2 .and. lo1.eq.lo2)then
		dist=0.
		azb=0.
		azf=0.
		return
	end if
c
	conv = 3.141592654 / 180.
	e0 = a*a - b*b          ! some eccentricities, not all of which
	e1 = e0 / (a*a)         ! are used.
	e2 = e0 / (b*b)
	e3 = e0 / (a*a + b*b)
	e4 = e0 / (a*b)
c
	lat1=la1*conv
	lon1=lo1*conv
	lat2=la2*conv
	lon2=lo2*conv
	dlon=lon2-lon1
c
	tanpsi1 =  b*b * tan(lat1) / (a*a)         ! geocentric lats
	tanpsi2 =  b*b * tan(lat2) / (a*a)
c
	psi1 = atan(tanpsi1)
	psi2 = atan(tanpsi2)
c
	azf = atan2 ( sin(dlon) ,                  !      fwd azimuth
     :        ( tanpsi2 - tanpsi1*cos(dlon) ) * cos(psi1) )
c
	azb = atan2 ( sin(-dlon) ,                 !      back azimuth
     :        ( tanpsi1 - tanpsi2*cos(-dlon) ) * cos(psi2) )
c
	theta1 = atan2(cos(azf),tanpsi1)
	theta2 = atan2(cos(azb),tanpsi2)
c
	beta0 = atan2 ( a * sqrt( tanpsi1*tanpsi1 +
     :          tanpsi2*tanpsi2 - 2.*tanpsi1*tanpsi2*
     :          cos(dlon) ) , b * sin(dlon) )
c
	bbar = b * sqrt ( 1. + e2 * cos(beta0)*cos(beta0) )
	mbar = (a*a - bbar*bbar) / (a*a + bbar*bbar)
c
	rad0 = sqrt ( .5 * (a*a+bbar*bbar) ) * ( 1. - mbar*mbar/16.)
	biga = mbar / 4. + 21.*mbar*mbar*mbar / 128.
	bigb = mbar*mbar / 64.
c
	s1=rad0*(theta1-biga*sin(2.*theta1)+bigb*sin(4.*theta1))
	s2=rad0*(theta2-biga*sin(2.*theta2)+bigb*sin(4.*theta2))
c
	dist = s1 + s2
	azf=azf/conv
	azb=azb/conv
	if(azf.lt.0.)azf=azf+360.
	if(azb.lt.0.)azb=azb+360.

	if(la1.eq.la2)then
		dist=(lo2-lo1)*cosd(la1)*110320.
	end if
c
	return
	end
c
        SUBROUTINE ENTERP(X,XT,YT,NX,NPX,Y,NERR)
        DIMENSION XT(1),YT(1)
        NERR=0
        INTER=1
        NP=NPX
        IF(NX.LT.NP) NP=NX
        IH=NP/2
        I=1
        IF(XT(I)-X)30,20,10
10        IH=0
12        NERR=1
        GO TO 70
13        NERR=2
        GO TO 70
20        INTER=2
22        Y=YT(I)
        GO TO 999
30        I=NX
        IF(XT(I)-X)13,20,40
40     N1=1
        N2=NX
45      MP=(N1+N2)/2
50      IF(XT(MP)-X)52,54,56
52      N1=MP
        GO TO 60
54      I=MP
        GO TO 20
56      N2=MP
60      IF(N2-N1.NE.1) GO TO 45
        I=MAX0(N2,IH+1)
70        K=I-IH
        N=K+NP-1
        Y=0.
        IF(N-NX)90,90,80
80        N=NX
        K=NX-NP+1
90        DO 120 J=K,N
        P=1.
        DO 110 I=K,N
        IF(I-J)100,110,100
100        P=P*(X-XT(I))/(XT(J)-XT(I))
110        CONTINUE
120        Y=Y+YT(J)*P
999      RETURN
        END
c
