c       dimension & type statements for ladcp2
c
	implicit none
c
	integer*4 bin_dim, ens_dim 
	integer*4 shear_dim,inn
c
	parameter (bin_dim = 25 , ens_dim = 18000, shear_dim = 240000)
c
        integer*4 inum
	real*4 xdif,ydif,zdif
	real*4 svapp,svel,sv_used,svratio
	integer*4 k,l,jj,nxb1,nyb1,nzb1
	real*8 ens_day
	real*4 zbd1,zbd2,usm0,usm1,vsm0,vsm1,usmn,vsmn,usq,vsq,ussd,vssd
	integer*4 nsm,nsh,nubad,nvbad
	integer*4 nubr,nvbr,nbot
	real*4 hhh,rll,ptt,ur1,ur2,vr1,vr2
	real*4 dum,sdum,topdif,botdif
	real*4 brefl1,brefl2,brefl3,brefl4,ubr,ubr2,vbr,vbr2
	real*4 ubmean,ubstd,vbmean,vbstd
	real*8 start_time,stop_time        
	real*8 start_val,stop_val        
	real*8 ensec
	real*4 start_dif,stop_dif
	real*4 zfacup,zfacdn,varmg
	integer*2 ix1,ix2,iy1,iy2
	integer*4 iens1,iens2,ntt1,ntt2,net,nvb,ifirst,ilast
	real*4 cdep,rdum
	real*4 rx1,rx2,ry1,ry2
	integer*2 julday
	integer*4 start_jd,start_hr,start_min,start_sec        
	integer*4 stop_jd,stop_hr,stop_min,stop_sec        
	integer*4 xv(bin_dim)
	integer*4 yv(bin_dim)
	integer*4 zv(bin_dim)
	integer*4 ev(bin_dim)
	integer*2 pg4(bin_dim)
	integer*2 i1(bin_dim)   
	integer*2 i2(bin_dim)   
	integer*2 i3(bin_dim)   
	integer*2 i4(bin_dim)
	integer*2 ibar(bin_dim)
	integer*2 iflag1(ens_dim)
	integer*2 iflag(ens_dim)
	integer*2 uflag(ens_dim,bin_dim)
	integer*2 vflag(ens_dim,bin_dim)
	integer*2 gdflag(ens_dim)
	real*4 z(bin_dim)
	real*4 vl1(ens_dim)
	real*4 vl2(ens_dim)
	real*4 vl3(ens_dim)
	real*8 vl0(ens_dim)
	real*8 csec(ens_dim)
	real*8 tt0
	real*8 sec
	real*8 deltim
	real*8 x1,y1,x2,y2,dst,az1,az2
	integer*2 ie(ens_dim)
	integer*2 il5(ens_dim)
	integer*4 ir1(shear_dim)
	integer*4 ie1(shear_dim)
	integer*2 day(ens_dim)
	integer*2 izmax
	integer*4 lbin(bin_dim)
	real*4 shd(bin_dim) 
	real*4 she(bin_dim) 
	real*4 shx(bin_dim)
	real*4 shy(bin_dim)
	real*4 shz(bin_dim) 
	real*4 shpg(bin_dim)
	real*4 depth(ens_dim) 
	real*4 hd(ens_dim) 
	real*4 rl(ens_dim)      
	real*4 pt(ens_dim) 
	real*4 sv_adcp(ens_dim)
	real*4 tmp(ens_dim)
	real*4 z1(shear_dim)
	real*4 u1(shear_dim)
	real*4 v1(shear_dim)
	real*4 w1(shear_dim)
	integer*2 p1(shear_dim)
	integer*2 e1(shear_dim)
	real*4 tmp1(shear_dim)
	integer*1 zflag(ens_dim) 
	integer*1 xflag(ens_dim) 
	integer*1 yflag(ens_dim)
	integer*4 nshear        
	integer*4 nr
	integer*4 i
	integer*4 j
	integer*4 nj
	integer*4 iday(7)
	integer*2 recl
	integer*2 growhandles
	integer*2 max_files
	integer*2 nbins
	integer*2 dalen
	integer*2 proc_yr
	integer*2 proc_mo 
	integer*2 proc_day
	integer*2 proc_hr
	integer*2 proc_min 
	integer*2 proc_sec 
	integer*2 proc_hun
	integer*2 bin_length
	integer*2 dist_to_first
	integer*4 grejul
	integer*2 nfirst
	integer*2 nlast
	integer*2 nzb
	integer*2 nx
	integer*2 ny
	integer*2 nz
	integer*2 wake_correct
	real*4 qecut,qzcut
	real*4 cut_4pg
	real*4 cut_err
	real*4 cut_z_std
	real*4 zbar
	real*4 zbar2
	real*4 xbar
	real*4 xbar2
	real*4 ybar
	real*4 ybar2
	real*4 zb0
	real*4 szb
	real*4 xb0
	real*4 sxb
	real*4 yb0
	real*4 syb
	real*4 s1
	real*4 xt1
	real*4 xt2
	real*4 yt1
	real*4 yt2
	real*4 zt1
	real*4 xdf
	real*4 ydf
	real*4 xrep
	real*4 yrep
	real*4 zrep
	real*4 xnet
	real*4 ynet
	real*4 znet
	real*4 zmax
	real*4 zbbr
	real*4 zfirst
	real*4 zlast
	real*4 x_uncor
	real*4 y_uncor
	real*4 utemp
	real*4 vtemp
	real*4 varcor
	real*4 u_ctd
	real*4 v_ctd
	real*4 zlbin
	real*4 z0
	real*4 shtest
	real*4 xdst
	real*4 ydst
	real*4 bx
	real*4 by
	real*4 cx
	real*4 cy
c
	character*23 day_time
	integer*2 istat
	integer*2 lib$date_time
	character fname*40
	character iname*80
	character*1 ew1,ew2,ns1,ns2
	logical*1 good

        inum=1
c
	open(unit=17,file='sj9705.time',status='new',form='formatted',
     :     carriagecontrol='list')
	open(unit=16,file='sj9705.pos',status='new',form='formatted',
     :     carriagecontrol='list')
c
	do inn=1,500
c
10	write(iname,890)inn,inn  !'Enter BB .INF file name'
890	format('[.df97',i3.3,']df97',i3.3,'.inf')
c	read(*,'(A)',end=100)iname
c
	open(unit=9,file=iname,form='formatted',readonly,
     :              status='old')
c
        
	read(9,'(a)')fname
c
	read(9,*)start_jd,start_hr,start_min,start_sec
	read(9,811)iy1,ry1,ns1
	read(9,811)ix1,rx1,ew1
	read(9,*)stop_jd,stop_hr,stop_min,stop_sec
	read(9,811)iy2,ry2,ns2
	read(9,811)ix2,rx2,ew2
811     format(i3,x,f6.3,x,a)
	start_time=start_jd+start_hr/24.+start_min/1440.+
     :      start_sec/86400.
	stop_time=stop_jd+stop_hr/24.+stop_min/1440.+stop_sec/86400.
c
	y1=iy1+ry1/60.
	x1=ix1+rx1/60.
	y2=iy2+ry2/60.
	x2=ix2+rx2/60.
	if(ns1.eq.'S')y1=-y1
	if(ns2.eq.'S')y2=-y2
	if(ew1.eq.'W')x1=-x1
	if(ew1.eq.'W')x2=-x2
c
	read(9,*)cdep             !,iens1,iens2
	read(9,*)zfacdn
	read(9,*)zfacup
	read(9,*)varmg
	close(9)
c
c	read(9,*)start_jd,start_hr,start_min,start_sec
        write(17,892)inn,start_time,stop_time
        write(16,882)inn,y1,x1,y2,x2
c
c	write(17,892)inum,'W'//iname(2:4),stop_jd,stop_hr,stop_min,
c     :   iy1,ry1,ix1,rx1,int(cdep)
892     format(x,i8,2f14.5)
882     format(x,i8,4f15.6)
c
c892	format(i3.3,x,a4,2x,i3,2x,i3,i3,i4,f6.2,i4,f6.2,i7)
c
        inum=inum+1
c	goto 10
c
	end do
c
100	stop
	end
