	implicit none
c
c       ladcp variables in order of appearance
c
	logical*1 is_header 
	logical*1 is_adcp_data
	logical*1 write_fixed_header
c
	integer*2 istat
	integer*2 lib$date_time
	integer*2 proc_yr
	integer*2 proc_mo
	integer*2 proc_day
	integer*2 proc_hr
	integer*2 proc_min
	integer*2 proc_sec
	integer*2 proc_hun
	integer*2 lrec
	integer*2 num_data_types 
	integer*2 header_length 
	integer*2 first_offset
	integer*2 second_offset
	integer*2 third_offset
	integer*2 fourth_offset
	integer*2 fifth_offset
	integer*2 sixth_offset
	integer*2 seventh_offset
c
	real*4 cpu_firmware_version
c
	integer*2 system_freq 
	integer*2 dalen 
	logical*1 trans_convex        
	logical*1 trans_face_up 
	integer*2 beam_angle 
c
	logical*1 real_data 
	integer*2 number_of_beams
	integer*2 number_of_bins 
	integer*2 pings_per_ensemble
	integer*2 bin_length 
	integer*2 blank_interval 
	integer*2 profile_mode 
	integer*2 corr_thresh 
	integer*2 code_reps 
	integer*2 percent_good_threshold 
	integer*2 error_threshold 
	integer*2 ping_interval
c
	logical*1 three_beam 
	logical*1 tilts_used 
	logical*1 earth_coords
	logical*1 beam_coords 
c
	integer*2 xducer_angle 
	integer*2 heading_bias
c
	logical*1 use_temp_sensor 
	logical*1 use_cond_sensor
	logical*1 use_roll_sensor 
	logical*1 use_pitch_sensor
	logical*1 use_head_sensor 
	logical*1 use_dep_sensor 
	logical*1 calc_sound
c
	integer*4 first_bin_dist 
	integer*4 pulse_length 
	integer*2 ref_layer_bin1
	integer*2 ref_layer_bin2 
	integer*2 false_targ_thresh 
	integer*4 transmit_lag 
c
	integer*4 ensemble_number 
	integer*2 ensemble_year 
	integer*2 ensemble_month
	integer*2 ensemble_day 
	integer*2 ensemble_hour 
	integer*2 ensemble_minute 
	integer*2 ensemble_second 
	integer*2 ensemble_hund_of_sec 
	integer*2 sound_vel 
	integer*2 depth_offset 
	integer*4 avg_heading 
	integer*2 avg_pitch 
	integer*2 avg_roll 
	integer*2 avg_sal 
	integer*2 avg_temp 
	integer*2 max_ping_time
	integer*2 std_dev_heading 
	integer*2 std_dev_pitch 
	integer*2 std_dev_roll 
	integer*2 ADC_0 
	integer*2 ADC_1 
	integer*2 ADC_2 
	integer*2 ADC_3 
	integer*2 ADC_4 
	integer*2 ADC_5 
	integer*2 ADC_6
c
	logical*1 vel_data_rec 
	integer*2 vel_x(128) 
	integer*2 vel_y(128) 
	integer*2 vel_z(128)
	integer*2 vel_err(128)
c
	logical*1 corr_data_rec 
	integer*2 corr_1(128) 
	integer*2 corr_2(128) 
	integer*2 corr_3(128) 
	integer*2 corr_4(128)
c
	logical*1 int_data_rec
	integer*2 int_1(128)
	integer*2 int_2(128) 
	integer*2 int_3(128) 
	integer*2 int_4(128)
c
	logical*1 pg_data_rec 
	integer*2 pg_1(128) 
	integer*2 pg_2(128) 
	integer*2 pg_3(128) 
	integer*2 pg_4(128)
c
	logical*1 stat_data_rec 
	integer*2 stat_1(128) 
	integer*2 stat_2(128) 
	integer*2 stat_3(128) 
	integer*2 stat_4(128)
c
	logical*1 bot_track_data_rec
	integer*2 bt_per_ensemble  
	integer*2 bt_delay 
	integer*2 bt_corr_min
	integer*2 bt_eval_min 
	integer*2 bt_mode 
	integer*2 bt_err_vel 
	integer*2 bt_search_pings
	integer*2 bt_track_pings 
	integer*2 bt_range_1 
	integer*2 bt_range_2 
	integer*2 bt_range_3 
	integer*2 bt_range_4 
	integer*2 bt_vel_1 
	integer*2 bt_vel_2 
	integer*2 bt_vel_3 
	integer*2 bt_vel_4 
	integer*2 bt_corr_1 
	integer*2 bt_corr_2 
	integer*2 bt_corr_3 
	integer*2 bt_corr_4 
	integer*2 bt_amp_1 
	integer*2 bt_amp_2 
	integer*2 bt_amp_3 
	integer*2 bt_amp_4 
	integer*2 bt_pg_1 
	integer*2 bt_pg_2 
	integer*2 bt_pg_3 
	integer*2 bt_pg_4 
	integer*2 bt_ref_min 
	integer*2 bt_ref_near 
	integer*2 bt_ref_far 
	integer*2 bt_max_depth
	integer*2 ref_vel_1 
	integer*2 ref_vel_2 
	integer*2 ref_vel_3 
	integer*2 ref_vel_4 
	integer*2 ref_corr_1 
	integer*2 ref_corr_2 
	integer*2 ref_corr_3 
	integer*2 ref_corr_4 
	integer*2 ref_amp_1 
	integer*2 ref_amp_2 
	integer*2 ref_amp_3 
	integer*2 ref_amp_4 
	integer*2 ref_pg_1 
	integer*2 ref_pg_2 
	integer*2 ref_pg_3 
	integer*2 ref_pg_4 
c
	integer*2 chksum
c
c       program variables
c
	logical*1 output_files_open
c
	integer*4 ick2 
	integer*4 ick2u 
	integer*4 bck1 
c
	integer*2 il5 
	integer*2 iline(512) 
	integer*2 eline(511)
	integer*2 l 
	integer*2 i
	integer*2 record_count
	integer*2 max_files
	integer*2 growhandles
c
	character*23 day_time
	character*80 ping_file_name
c
	integer*1 line(2048)
c
c       output variables        
c
	real*4 xmit_cur
	real*4 xmit_volt
	real*4 internal_temp
	real*4 vdd3
	real*4 vdd1
	real*4 vdc
	real*4 start_batt
	real*4 stop_batt
c
	equivalence (line(1),iline(1))
	equivalence (line(2),eline(1))
c
c	max_files = growhandles (50)        ! for pc version
c        
	dalen=80
	open(unit=14,file='process.inf',status='unknown',form=
     :  'formatted',access='direct',recl=dalen)
c
c	call getdat(proc_yr,proc_mo,proc_day)
c	call gettim(proc_hr,proc_min,proc_sec,proc_hun)
	istat=lib$date_time(day_time)
c
	write(*,*)'Enter complete ladcp raw file name'
	read(*,'(a)') ping_file_name
	open(unit=11,file=ping_file_name,status='old',readonly,
     :       form='unformatted',recordtype='fixed')
c
	write(14,fmt='(a)',rec=1) ping_file_name
	write(14,fmt=810,rec=2)day_time !proc_day,proc_mo,proc_yr,proc_hr,
c     :   proc_min,proc_sec
810     format('Raw File Processed at 'a40) !,i2.2,'/',i2.2,'/',i4.4,4x,
!     :  i2.2,':',i2.2,':',i2.2)
c
	read(11)(line(i),i=1,5)
	lrec=ick2(line(3))+2
	close(11)
	write(*,*)' Fixed record length is ',lrec,' bytes'        
	dalen=80
	open(unit=9,file='fixhdr.inf',status='unknown',form='formatted',        
     :  access='direct',recl=dalen)
c
	write_fixed_header=.true.
	write(14,fmt='(a)',rec=3) 'Fixed Header data in FIXHDR.INF'
	open(unit=11,file=ping_file_name,status='old',readonly,
     :       form='unformatted',recordtype='fixed')
c
	record_count=1        
	output_files_open=.false.
c
	write(*,*)'Processing LADCP raw file - stand by...'        
	read(11)(line(i),i=1,lrec)
c
5       if( bck1(line(1)) .eq. 127) then
		is_header = .true.
	else
c
		write(*,*) 'First record is not a header record'
		stop
	end if
c
	if( bck1(line(2)) .eq. 127) then
		is_adcp_data = .true.
	end if

	if((ick2(line(3))+2).ne.lrec)then
	write(*,*) ' Actual record length not equal fixed record length'
	write(*,*) ick2(line(3))+2
	stop
	end if
c
	num_data_types = bck1(line(6))
c
	if(num_data_types.ge.1)first_offset=ick2(line(7))
	if(num_data_types.ge.2)second_offset=ick2(line(9))
	if(num_data_types.ge.3)third_offset=ick2(line(11))
	if(num_data_types.ge.4)fourth_offset=ick2(line(13))
	if(num_data_types.ge.5)fifth_offset=ick2(line(15))
	if(num_data_types.ge.6)sixth_offset=ick2(line(17))
	if(num_data_types.ge.7)seventh_offset=ick2(line(19))
c        
	header_length = 2*num_data_types + 6
c
	l=header_length
c
	if(ick2(line(l+1)).ne.0)then
		write(*,*) 'No fixed Leader data'
		stop
	end if
c
	il5=(l+4)/2
c
	cpu_firmware_version=
     :         float(bck1(line(l+3)))+float(bck1(line(l+4)))/100.
c
		system_freq = (2 ** mod(ick2(line(l+5)),8) ) * 75
		trans_convex = btest(iline(il5+1),3)
		trans_face_up = btest(iline(il5+1),7)
		if(btest(iline(il5+1),9)) then
			if(btest(iline(il5+1),8)) then
			beam_angle=0
			else
			beam_angle=30
			end if
		else
			if(btest(iline(il5+1),8)) then
			beam_angle=15
			else
			beam_angle=20
			end if
		end if          
		real_data = .false.
		if(bck1(line(l+7)).eq.0) real_data = .true.
c
		number_of_beams = bck1(line(l+9))
		number_of_bins = bck1(line(l+10))
c
		if(.not.output_files_open)then
		call open_output_files(number_of_bins)
		output_files_open = .true.
		end if
c
		pings_per_ensemble = ick2(line(l+11))
		bin_length = ick2(line(l+13))
		blank_interval = ick2(line(l+15))
		profile_mode = bck1(line(l+17))
		corr_thresh =  bck1(line(l+18))
		code_reps =  bck1(line(l+19))
		percent_good_threshold = bck1(line(l+20))
		error_threshold = ick2(line(l+21))
c
		ping_interval = bck1(line(l+23))*6000 + 
     :          bck1(line(l+24))*100 +  bck1(line(l+25))*1
		il5=(l+26)/2
		if(btest(eline(il5),1)) three_beam = .true.
		if(btest(eline(il5),2)) tilts_used = .true.
		if(btest(eline(il5),3) .and. btest(eline(il5),4)) 
     :            earth_coords  = .true.
		if(.not.btest(eline(il5),3) .and. .not.
     :          btest(eline(il5),4)) beam_coords  = .true.
		xducer_angle = ick2(line(l+27)) !hundredths of deg
		heading_bias = ick2(line(l+29)) !hundredths of deg
c
		il5=(l+30)/2 + 1
		if(btest(iline(il5),0)) use_temp_sensor = .true.
		if(btest(iline(il5),1)) use_cond_sensor = .true.
		if(btest(iline(il5),2)) use_roll_sensor = .true.
		if(btest(iline(il5),3)) use_pitch_sensor = .true.
		if(btest(iline(il5),4)) use_head_sensor = .true.
		if(btest(iline(il5),5)) use_dep_sensor = .true.
		if(btest(iline(il5),6)) calc_sound = .true.
c
		first_bin_dist = ick2(line(l+33))       !cm
		pulse_length = ick2(line(l+35))         !cm
		ref_layer_bin1 = bck1(line(l+37))
		ref_layer_bin2 = bck1(line(l+38))
		false_targ_thresh =  bck1(line(l+39))    ! counts 0-255
		transmit_lag = ick2(line(l+41))         !cm
c
c       write fixed header info        
	if(write_fixed_header)then        
	write(9,fmt='(a)',rec=1)ping_file_name
	write(9,fmt=902,rec=2)num_data_types 
902     format(' Number of data types',19x,i6) 
	write(9,fmt=903,rec=3) cpu_firmware_version
903     format(' CPU firmware version',19x,f6.2)        
	write(9,fmt=904,rec=4) system_freq 
904     format(' System frequency',23x,i6,' kHz')
	write(9,fmt=905,rec=5) trans_convex    
905     format(' Transducer Convex',22x,l6)        
	write(9,fmt=906,rec=6)trans_face_up
906     format(' Transducers facing Up',18x,l6)        
	write(9,fmt=907,rec=7) beam_angle 
907     format(' Transducer beam angle',18x,i6)        
	write(9,fmt=908,rec=8) real_data 
908     format(' Real data',30x,l6)        
	write(9,fmt=909,rec=9) number_of_beams
909     format(' Number of Beams',24x,i6)   
	write(9,fmt=910,rec=10) number_of_bins 
910     format(' Number of bins',25x,i6)        
	write(9,fmt=911,rec=11) pings_per_ensemble
911     format(' Pings per Ensemble',21x,i6)        
	write(9,fmt=912,rec=12) bin_length 
912     format(' Bin Length',29x,i6)        
	write(9,fmt=913,rec=13) blank_interval 
913     format(' Blanking Interval',22x,i6)        
	write(9,fmt=914,rec=14) profile_mode 
914     format(' Profiling Mode',25x,i6)        
	write(9,fmt=915,rec=15) corr_thresh 
915     format(' Minimum Correlation Threshhold',9x,i6)        
	write(9,fmt=916,rec=16) code_reps 
916     format(' Code Repititions',23x,i6)        
	write(9,fmt=917,rec=17) percent_good_threshold 
917     format(' Percent Good Threshhold',16x,i6)
	write(9,fmt=918,rec=18) error_threshold 
918     format(' Error Velocity Threshhold',14x,i6)        
	write(9,fmt=919,rec=19) ping_interval
919     format(' Ping Interval',26x,i6)
	write(9,fmt=920,rec=20) three_beam 
920     format(' Use three-beam solutions',15x,l6)        
	write(9,fmt=921,rec=21) tilts_used 
921     format(' Correct for Tilt',23x,l6)
	write(9,fmt=922,rec=22) earth_coords
922     format(' Velocity in Earth Coordinates',10x,l6)        
	write(9,fmt=923,rec=23) beam_coords 
923     format(' Velocity in Beam Coordinates',11x,l6)        
	write(9,fmt=924,rec=24) xducer_angle 
924     format(' Transducer Alignment Angle',13x,i6)
	write(9,fmt=925,rec=25) heading_bias
925     format(' Heading Bias',27x,i6)        
	write(9,fmt=926,rec=26) use_temp_sensor 
926     format(' Use Temperature Sensor',17x,l6)        
	write(9,fmt=927,rec=27) use_cond_sensor
927     format(' Use Conductivity Sensor',16x,l6)        
	write(9,fmt=928,rec=28) use_roll_sensor 
928     format(' Use Roll Sensor',24x,l6)        
	write(9,fmt=929,rec=29) use_pitch_sensor
929     format(' Use Pitch Sensor',23x,l6)        
	write(9,fmt=930,rec=30) use_head_sensor 
930     format(' Use Heading Sensor',21x,l6)        
	write(9,fmt=931,rec=31) use_dep_sensor 
931     format(' Use Pressure Sensor',20x,l6)        
	write(9,fmt=932,rec=32) calc_sound
932     format(' Calculate Sound Velocity',15x,l6)        
	write(9,fmt=933,rec=33) first_bin_dist 
933     format(' Distance to Center of First Bin',8x,i6)        
	write(9,fmt=934,rec=34) pulse_length 
934     format(' Pulse Length',27x,i6)        
	write(9,fmt=935,rec=35) ref_layer_bin1
935     format(' Reference Layer First Bin',14x,i6)        
	write(9,fmt=936,rec=36) ref_layer_bin2 
936     format(' Reference Layer Last Bin',15x,i6)        
	write(9,fmt=937,rec=37) false_targ_thresh 
937     format(' False Target Threshhold',16x,i6)        
	write(9,fmt=938,rec=38) transmit_lag 
938     format(' Transmit Lag',27x,i6)        
c                
	write_fixed_header=.false.
	close(9)
	end if
c
	l=l+42
c
		ensemble_number = ick2(line(l+3))+ick2(line(l+12))*65536
		write(37,837,rec=record_count)ensemble_number
837             format(i8)
c
		ensemble_year = bck1(line(l+5))
		ensemble_month = bck1(line(l+6))
		ensemble_day = bck1(line(l+7))
		ensemble_hour = bck1(line(l+8))
		ensemble_minute = bck1(line(l+9))
		ensemble_second = bck1(line(l+10))
		ensemble_hund_of_sec = bck1(line(l+11))
		write(38,838,rec=record_count)
     :          ensemble_year,ensemble_month,ensemble_day,
     :          ensemble_hour,ensemble_minute,ensemble_second,
     :          ensemble_hund_of_sec
838             format(7i5)
c
c               bits 13,14 are Built in Test codes
c
		sound_vel =  ick2(line(l+15))           ! m/s
		depth_offset = ick2(line(l+17))         ! decimeters
		avg_heading = ick2u(line(l+19))         ! .01 degrees
		avg_pitch = ick2(line(l+21))            ! .01 degrees
		avg_roll = ick2(line(l+23))             ! .01 degrees
		avg_sal =  ick2(line(l+25))             ! PSU
		avg_temp = ick2(line(l+27))             ! .01 degree C
c
		write(39,839,rec=record_count)
     :          avg_temp/100.,float(avg_sal),
     :          float(sound_vel)
839             format(f8.2,2f7.0)
c
		max_ping_time = bck1(line(l+29))*6000 + 
     :          bck1(line(l+30))*100 +  bck1(line(l+31))*1 ! .01 sec
		std_dev_heading =  bck1(line(l+32))             ! degrees
		std_dev_pitch =  bck1(line(l+33))               ! 0.1 degrees
		std_dev_roll =  bck1(line(l+34))                ! 0.1 degrees
c
		write(40,840,rec=record_count)
     :           float(avg_heading)/100.,float
     :          (std_dev_heading),float(avg_roll)/100.,float
     :          (std_dev_roll)/10.,avg_pitch/100.,
     :          float(std_dev_pitch)/10.
840     format(6f9.2)
c
		ADC_0 =  bck1(line(l+35))       ! xmit current
		ADC_1 =  bck1(line(l+36))       ! xmit voltage
		ADC_2 =  bck1(line(l+37))       ! DAC output
		ADC_3 =  bck1(line(l+38))       ! internal temp
		ADC_4 =  bck1(line(l+39))       ! VDD3
		ADC_5 =  bck1(line(l+40))       ! VDD1
		ADC_6 =  bck1(line(l+41))       ! VDc
c
	xmit_cur=0.057*float(adc_0)
	xmit_volt=1.690*float(adc_1)
	internal_temp=(1419. * float(adc_3) - 273150.)/1000. 
	vdd3=0.097*float(adc_4)
	vdd1=0.032*float(adc_5)
	vdc=0.307*float(adc_6)
c
	if(record_count.eq.10)start_batt=vdc        
	stop_batt=vdc
	write(41,841,rec=record_count)
     :  xmit_cur,xmit_volt,adc_2,internal_temp,
     :               vdd3,vdd1,vdc
841     format(2f8.1,i6,4f8.1)
c
	l=l+42
c
		if(ick2(line(l+1)).eq.256) then
			vel_data_rec = .true.
c
		do i=1,number_of_bins
		   vel_x(i)=ick2(line(l+2+(i-1)*8+1))
		   vel_y(i)=ick2(line(l+2+(i-1)*8+3))
		   vel_z(i)=ick2(line(l+2+(i-1)*8+5))
		   vel_err(i)=ick2(line(l+2+(i-1)*8+7))
		end do
c 
	write(21,821,rec=record_count)(vel_x(i),i=1,number_of_bins)
	write(22,821,rec=record_count)(vel_y(i),i=1,number_of_bins)
	write(23,821,rec=record_count)(vel_z(i),i=1,number_of_bins)
	write(24,821,rec=record_count)(vel_err(i),i=1,number_of_bins)
821     format(128i8)
c
		l=l+8*number_of_bins + 2
c
		end if
c
		if(ick2(line(l+1)).eq.512) then
			corr_data_rec = .true.
c
		do i=1,number_of_bins
		   corr_1(i)=bck1(line(l+2+(i-1)*4+1))
		   corr_2(i)=bck1(line(l+2+(i-1)*4+2))
		   corr_3(i)=bck1(line(l+2+(i-1)*4+3))
		   corr_4(i)=bck1(line(l+2+(i-1)*4+4))
		end do
c
	write(25,825,rec=record_count)(corr_1(i),i=1,number_of_bins)
	write(26,825,rec=record_count)(corr_2(i),i=1,number_of_bins)
	write(27,825,rec=record_count)(corr_3(i),i=1,number_of_bins)
	write(28,825,rec=record_count)(corr_4(i),i=1,number_of_bins)
825     format(128i5)
c
		l=l+4*number_of_bins + 2
c
		end if
c
		if(ick2(line(l+1)).eq.768) then
			int_data_rec = .true.
c
		do i=1,number_of_bins
		   int_1(i)=bck1(line(l+2+(i-1)*4+1))
		   int_2(i)=bck1(line(l+2+(i-1)*4+2))
		   int_3(i)=bck1(line(l+2+(i-1)*4+3))
		   int_4(i)=bck1(line(l+2+(i-1)*4+4))
		end do
c
	write(29,829,rec=record_count)(int_1(i),i=1,number_of_bins)
	write(30,829,rec=record_count)(int_2(i),i=1,number_of_bins)
	write(31,829,rec=record_count)(int_3(i),i=1,number_of_bins)
	write(32,829,rec=record_count)(int_4(i),i=1,number_of_bins)
829     format(128i5)
c
		l=l+4*number_of_bins + 2
c
		end if
c
		if(ick2(line(l+1)).eq.1024) then
			pg_data_rec = .true.
c
		do i=1,number_of_bins
		   pg_1(i)=bck1(line(l+2+(i-1)*4+1))
		   pg_2(i)=bck1(line(l+2+(i-1)*4+2))
		   pg_3(i)=bck1(line(l+2+(i-1)*4+3))
		   pg_4(i)=bck1(line(l+2+(i-1)*4+4))
		end do
c
	write(33,833,rec=record_count)(pg_1(i),i=1,number_of_bins)
	write(34,833,rec=record_count)(pg_2(i),i=1,number_of_bins)
	write(35,833,rec=record_count)(pg_3(i),i=1,number_of_bins)
	write(36,833,rec=record_count)(pg_4(i),i=1,number_of_bins)
833     format(128i5)
c
		l=l+4*number_of_bins + 2
c
		end if

		if(ick2(line(l+1)).eq.1280) then
			stat_data_rec = .true.
c
		do i=1,number_of_bins
		   stat_1(i)=bck1(line(l+2+(i-1)*4+1))
		   stat_2(i)=bck1(line(l+2+(i-1)*4+2))
		   stat_3(i)=bck1(line(l+2+(i-1)*4+3))
		   stat_4(i)=bck1(line(l+2+(i-1)*4+4))
		end do
c
		l=l+4*number_of_bins + 2
c
		end if
c
		if(ick2(line(l+1)).eq.1536) then
c
		bot_track_data_rec = .true.
		bt_per_ensemble = ick2(line(l+3))
		bt_delay = ick2(line(l+5))
		bt_corr_min= bck1(line(l+7))
		bt_eval_min= bck1(line(l+8))
		bt_mode= bck1(line(l+10))
		bt_err_vel = ick2(line(l+11))          ! mm / s
		bt_search_pings = ick2(line(l+13))
		bt_track_pings = ick2(line(l+15))
c
		bt_range_1 = ick2(line(l+17))
		bt_range_2 = ick2(line(l+19))
		bt_range_3 = ick2(line(l+21))
		bt_range_4 = ick2(line(l+23))
c
		bt_vel_1 = ick2(line(l+25))
		bt_vel_2 = ick2(line(l+27))
		bt_vel_3 = ick2(line(l+29))
		bt_vel_4 = ick2(line(l+31))
c
		bt_corr_1 = bck1(line(l+33))
		bt_corr_2 = bck1(line(l+34))
		bt_corr_3 = bck1(line(l+35))
		bt_corr_4 = bck1(line(l+36))
c
		bt_amp_1 = bck1(line(l+37))
		bt_amp_2 = bck1(line(l+38))
		bt_amp_3 = bck1(line(l+39))
		bt_amp_4 = bck1(line(l+40))
c
		bt_pg_1 = bck1(line(l+41))
		bt_pg_2 = bck1(line(l+42))
		bt_pg_3 = bck1(line(l+43))
		bt_pg_4 = bck1(line(l+44))
c
		bt_ref_min = ick2(line(l+45))
		bt_ref_near = ick2(line(l+47))
		bt_ref_far = ick2(line(l+49))
c
		ref_vel_1 = ick2(line(l+51))
		ref_vel_2 = ick2(line(l+53))
		ref_vel_3 = ick2(line(l+55))
		ref_vel_4 = ick2(line(l+57))
c
		ref_corr_1 = bck1(line(l+59))
		ref_corr_2 = bck1(line(l+60))
		ref_corr_3 = bck1(line(l+61))
		ref_corr_4 = bck1(line(l+62))
c
		ref_amp_1 = bck1(line(l+63))
		ref_amp_2 = bck1(line(l+64))
		ref_amp_3 = bck1(line(l+65))
		ref_amp_4 = bck1(line(l+66))
c
		ref_pg_1 = bck1(line(l+67))
		ref_pg_2 = bck1(line(l+68))
		ref_pg_3 = bck1(line(l+69))
		ref_pg_4 = bck1(line(l+70))
c
		bt_max_depth = ick2(line(l+71))
c
c        SAVE FOR BT FILE - not yet implemented        
c        write(19,801) bot_track_data_rec
c        write(19,802) bt_per_ensemble  
c        write(19,802) bt_delay 
c        write(19,802) bt_corr_min
c        write(19,802) bt_eval_min 
c        write(19,802) bt_mode 
c        write(19,802) bt_err_vel 
c        write(19,802) bt_search_pings
c        write(19,802) bt_track_pings 
c        write(19,802) bt_range_1 
c        write(19,802) bt_range_2 
c        write(19,802) bt_range_3 
c        write(19,802) bt_range_4 
c        write(19,802) bt_vel_1 
c        write(19,802) bt_vel_2 
c        write(19,802) bt_vel_3 
c        write(19,802) bt_vel_4 
c        write(19,802) bt_corr_1 
c        write(19,802) bt_corr_2 
c        write(19,802) bt_corr_3 
c        write(19,802) bt_corr_4 
c        write(19,802) bt_amp_1 
c        write(19,802) bt_amp_2 
c        write(19,802) bt_amp_3 
c        write(19,802) bt_amp_4 
c        write(19,802) bt_pg_1 
c        write(19,802) bt_pg_2 
c        write(19,802) bt_pg_3 
c        write(19,802) bt_pg_4 
c        write(19,802) bt_ref_min 
c        write(19,802) bt_ref_near 
c        write(19,802) bt_ref_far 
c        write(19,802) bt_max_depth
c        write(19,802) ref_vel_1 
c        write(19,802) ref_vel_2 
c        write(19,802) ref_vel_3 
c        write(19,802) ref_vel_4 
c        write(19,802) ref_corr_1 
c        write(19,802) ref_corr_2 
c        write(19,802) ref_corr_3 
c        write(19,802) ref_corr_4 
c        write(19,802) ref_amp_1 
c        write(19,802) ref_amp_2 
c        write(19,802) ref_amp_3 
c        write(19,802) ref_amp_4 
c        write(19,802) ref_pg_1 
c        write(19,802) ref_pg_2 
c        write(19,802) ref_pg_3 
c        write(19,802) ref_pg_4 
c*****************************

	l=l+72
c
	end if
c
	chksum= ick2(line(l+1))
c
	record_count=record_count+1
	if(mod(ensemble_number,1000).eq.0)print 985,ensemble_number
985     format('Processed ensemble number ',i8)
c
	read(11,END=99)(line(i),i=1,lrec)
c
	goto 5
c
99      write(*,986)stop_batt
986     format('Final Battery Voltage ',f6.1)
c        
	stop
	end
c
	function bck1(barg)
	integer*4 bck1
	integer*1 barg
c
	if(barg.lt.0)then
		bck1=256+barg
	else
		bck1=barg
	end if
c
	return
	end
c
	function ick2u(iarg)     !  unsigned 16 bit integer
	integer*2 iarg
	integer*4 ick2u
	ick2u=iarg
	if(ick2u.lt.0)ick2u=ick2u+65536
	return
	end
c
	function ick2(iarg)      !  signed 16 bit integer
	integer*2 iarg
	integer*4 ick2
	ick2=iarg
	return
	end
c
	subroutine open_output_files (number_of_bins)
c
	integer*2 recl , number_of_bins
c
	recl=number_of_bins * 8 + 2 
       open(unit=21,file='v1.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=22,file='v2.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=23,file='v3.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=24,file='v4.out',status='new',form='formatted',
     :  access='direct',recl=recl)

       recl=number_of_bins * 5 + 2 
       open(unit=25,file='c1.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=26,file='c2.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=27,file='c3.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=28,file='c4.out',status='new',form='formatted',
     :  access='direct',recl=recl)

       open(unit=29,file='i1.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=30,file='i2.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=31,file='i3.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=32,file='i4.out',status='new',form='formatted',
     :  access='direct',recl=recl)

       open(unit=33,file='p1.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=34,file='p2.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=35,file='p3.out',status='new',form='formatted',
     :  access='direct',recl=recl)
       open(unit=36,file='p4.out',status='new',form='formatted',
     :  access='direct',recl=recl)

	open(unit=37,file='ens.out',status='new',form='formatted',
     :  access='direct',recl=10)
	open(unit=38,file='time.out',status='new',form='formatted',
     :  access='direct',recl=40)
	open(unit=39,file='hydro.out',status='new',form='formatted',
     :  access='direct',recl=24)
	open(unit=40,file='hrp.out',status='new',form='formatted',
     :  access='direct',recl=60)
	open(unit=41,file='adc.out',status='new',form='formatted',
     :  access='direct',recl=70)
c
	return
	end
