c       dimension & type statements for ladcp2
c
	implicit none
c
	integer*4 bin_dim, ens_dim 
	integer*4 shear_dim
c
	parameter (bin_dim = 25 , ens_dim = 18000, shear_dim = 240000)
c
	integer idbot,iubot,kk,ii,nbotav,ikk
	real estbot,botav,cbot,thisbot,bthresh
	real*4 xdif,ydif,zdif
	real*4 svapp,svel,sv_used,svratio
	integer*4 k,l,jj,nxb1,nyb1,nzb1
	real*8 ens_day
	real*4 zbd1,zbd2,usm0,usm1,vsm0,vsm1,usmn,vsmn,usq,vsq,ussd,vssd
	integer*4 nsm,nsh,nubad,nvbad
	integer*4 nubr,nvbr,nbot
	real*4 hhh,rll,ptt,ur1,ur2,vr1,vr2
	real*4 dum,sdum,topdif,botdif
	real*4 brefl1,brefl2,brefl3,brefl4,ubr,ubr2,vbr,vbr2
	real*4 ubmean,ubstd,vbmean,vbstd
	real*8 start_time,stop_time        
	real*8 start_val,stop_val        
	real*8 ensec
	real*4 start_dif,stop_dif
	real*4 zfacup,zfacdn,varmg
	integer*2 ix1,ix2,iy1,iy2
	integer*4 iens1,iens2,ntt1,ntt2,net,nvb,ifirst,ilast
	real*4 cdep,rdum
	real*4 rx1,rx2,ry1,ry2
	integer*2 julday,botmax
	integer*4 start_jd,start_hr,start_min,start_sec        
	integer*4 stop_jd,stop_hr,stop_min,stop_sec        
	integer*4 xv(bin_dim)
	integer*4 yv(bin_dim)
	integer*4 zv(bin_dim)
	integer*4 ev(bin_dim)
	integer*2 pg4(bin_dim)
	integer*2 i1(bin_dim)   
	integer*2 i2(bin_dim)   
	integer*2 i3(bin_dim)   
	integer*2 i4(bin_dim)
	integer*2 ibar(bin_dim)
	integer*2 iflag1(ens_dim)
	integer*2 iflag(ens_dim)
	integer*2 uflag(ens_dim,bin_dim)
	integer*2 vflag(ens_dim,bin_dim)
	integer*2 gdflag(ens_dim)
	integer*2 bfind(1000,bin_dim)
	integer*2 botbin(bin_dim)
	integer*2 botinten(bin_dim)
	real*4 z(bin_dim)
	real*4 vl1(ens_dim)
	real*4 vl2(ens_dim)
	real*4 vl3(ens_dim)
	real*8 vl0(ens_dim)
	real*8 csec(ens_dim)
	real*8 tt0
	real*8 sec
	real*8 deltim
	real*8 x1,y1,x2,y2,dst,az1,az2
	integer*2 ie(ens_dim)
	integer*2 il5(ens_dim)
	integer*4 ir1(shear_dim)
	integer*4 ie1(shear_dim)
	integer*2 day(ens_dim)
	integer*2 izmax
	integer*4 lbin(bin_dim)
	real*4 shd(bin_dim) 
	real*4 she(bin_dim) 
	real*4 shx(bin_dim)
	real*4 shy(bin_dim)
	real*4 shz(bin_dim) 
	real*4 shpg(bin_dim)
	real*4 depth(ens_dim) 
	real*4 hd(ens_dim) 
	real*4 rl(ens_dim)      
	real*4 pt(ens_dim) 
	real*4 sv_adcp(ens_dim)
	real*4 tmp(ens_dim)
	real*4 z1(shear_dim)
	real*4 u1(shear_dim)
	real*4 v1(shear_dim)
	real*4 w1(shear_dim)
	integer*2 p1(shear_dim)
	integer*2 e1(shear_dim)
	real*4 tmp1(shear_dim)
	integer*1 zflag(ens_dim) 
	integer*1 xflag(ens_dim) 
	integer*1 yflag(ens_dim)
	integer*4 nshear        
	integer*4 nr
	integer*4 i
	integer*4 j
	integer*4 nj
	integer*4 iday(7)
	integer*2 recl
	integer*2 growhandles
	integer*2 max_files
	integer*2 nbins
	integer*2 dalen
	integer*2 proc_yr
	integer*2 proc_mo 
	integer*2 proc_day
	integer*2 proc_hr
	integer*2 proc_min 
	integer*2 proc_sec 
	integer*2 proc_hun
	integer*4 bin_length
	integer*4 dist_to_first
	integer*4 grejul
	integer*2 nfirst
	integer*2 nlast
	integer*2 nzb
	integer*2 nx
	integer*2 ny
	integer*2 nz
	integer*2 wake_correct
	real*4 qecut,qzcut
	real*4 cut_4pg
	real*4 cut_err
	real*4 cut_z_std
	real*4 zbar
	real*4 zbar2
	real*4 xbar
	real*4 xbar2
	real*4 ybar
	real*4 ybar2
	real*4 zb0
	real*4 szb
	real*4 xb0
	real*4 sxb
	real*4 yb0
	real*4 syb
	real*4 s1
	real*4 xt1
	real*4 xt2
	real*4 yt1
	real*4 yt2
	real*4 zt1
	real*4 xdf
	real*4 ydf
	real*4 xrep
	real*4 yrep
	real*4 zrep
	real*4 xnet
	real*4 ynet
	real*4 znet
	real*4 zmax
	real*4 zbbr
	real*4 zfirst
	real*4 zlast
	real*4 x_uncor
	real*4 y_uncor
	real*4 utemp
	real*4 vtemp
	real*4 varcor
	real*4 u_ctd
	real*4 v_ctd
	real*4 zlbin
	real*4 z0
	real*4 shtest
	real*4 xdst
	real*4 ydst
	real*4 bx
	real*4 by
	real*4 cx
	real*4 cy
c
	character*23 day_time
	integer*2 istat
	integer*2 lib$date_time
	character fname*40
	character iname*80
	character*1 ew1,ew2,ns1,ns2
	logical*1 good
c
c	max_files=growhandles(50)        
c
c
	good=.false.
	write(*,*)'Enter BB .INF file name'
	read(*,'(A)')iname
c
	open(unit=9,file=iname,form='formatted',readonly,
     :              status='old')
c
	read(9,'(a)')fname
c
	read(9,*)start_jd,start_hr,start_min,start_sec
c	type *,start_jd,start_hr,start_min,start_sec
	read(9,811)iy1,ry1,ns1
	read(9,811)ix1,rx1,ew1
	read(9,*)stop_jd,stop_hr,stop_min,stop_sec
c	type *,stop_jd,stop_hr,stop_min,stop_sec
	read(9,811)iy2,ry2,ns2
	read(9,811)ix2,rx2,ew2
811     format(i3,x,f6.3,x,a)
	start_time=start_jd+start_hr/24.+start_min/1440.+
     :      start_sec/86400.
	stop_time=stop_jd+stop_hr/24.+stop_min/1440.+stop_sec/86400.
c
c	type *,start_time,stop_time
c
	y1=iy1+ry1/60.
	x1=ix1+rx1/60.
	y2=iy2+ry2/60.
	x2=ix2+rx2/60.
	if(ns1.eq.'S')y1=-y1
	if(ns2.eq.'S')y2=-y2
	if(ew1.eq.'W')x1=-x1
	if(ew1.eq.'W')x2=-x2
c
	read(9,*)cdep             !,iens1,iens2
	read(9,*)zfacdn
	read(9,*)zfacup
	read(9,*)varmg
	close(9)
c
	varmg=varmg*.017453293
	cut_z_std=100.        
	cut_4pg=60. 
	cut_err=60.
c
	write(*,*)'Enter Z std dev cutoff and error velocity cutoff'
	read(*,*)qzcut,qecut
	if(qecut.gt.0)cut_err=qecut        
	if(qzcut.gt.0)cut_z_std=qzcut        
c        
1111    dalen=80
	ifirst=0
	open(unit=14,file='process.inf',status='unknown',form=
     :  'formatted',access='direct',recl=dalen)
c
	istat=lib$date_time(day_time)
c
c	call getdat(proc_yr,proc_mo,proc_day)
c	call gettim(proc_hr,proc_min,proc_sec,proc_hun)
c
	write(14,fmt=810,rec=4)day_time !proc_day,proc_mo,proc_yr,proc_hr,
c     :   proc_min,proc_sec
810     format('Raw File Processed at ',a23 ) !i2.2,'/',i2.2,'/',i4.4,4x,
c     :  i2.2,':',i2.2,':',i2.2)
c
43        rdum=-999.9
c
	write(14,rec=5,fmt='(2f8.1)')cut_4pg,cut_err
c        
	dalen=80
	open(unit=9,file='fixhdr.inf',status='old',form='formatted',        
     :  access='direct',recl=dalen)
	read(9,fmt=910,rec=10) nbins 
910     format(40x,i6)        
	read(9,fmt=910,rec=12) bin_length 
	read(9,fmt=910,rec=33) dist_to_first 
	close(9)
c
	open(unit=61,file='time.out',status='old',readonly,
     :   access='direct',recl=40,form='formatted')
	open(unit=62,file='ens.out',status='old',readonly,
     :   access='direct',recl=10,form='formatted')
	open(unit=63,file='hrp.out',status='old',readonly,
     :   access='direct',recl=60,form='formatted')
	open(unit=64,file='hydro.out',status='old',readonly,
     :   access='direct',recl=24,form='formatted')
c
	recl=nbins * 8 + 2
	open(unit=65,file='v1.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=66,file='v2.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=67,file='v3.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=68,file='v4.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
c
	recl=nbins * 5 + 2
	open(unit=69,file='i1.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=70,file='i2.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=71,file='i3.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
	open(unit=72,file='i4.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
c
	open(unit=73,file='p4.out',status='old',readonly,
     :   access='direct',recl=recl,form='formatted')
c
48	open(unit=76,file='vels.out',status='unknown',
     :   access='direct',recl=40,form='formatted')
c
	if(good)then
	open(unit=19,file='good.out',status='old',readonly,
     :   access='direct',recl=80,form='formatted')
	end if
c
	zmax=0
	nvb=0
	net=0
	nj=0
	znet=4.
c
	ntt1=0        
	ntt2=0
c
c       find ensemble numbers for start, stop        
c       
	start_val=1e8
	stop_val=1e8
	do jj=1,100000
	read(61,rec=jj,fmt='(7i5)',err=95)(iday(k),k=1,7)
	Julday=grejul(iday(1),iday(2),iday(3)) 
	ensec=iday(4)*60*60*100+iday(5)*60*100+iday(6)*100+iday(7)
	ens_day=julday+ensec/8640000.
	start_dif=abs(ens_day-start_time)*86400.
	stop_dif=abs(ens_day-stop_time)*86400.
c	type *,iday
c	type *,jj,ens_day,start_dif,stop_dif
	if(start_dif .lt. start_val)then
		iens1=jj
		start_val=start_dif
	end if
	if(stop_dif .lt. stop_val)then
		iens2=jj
		stop_val=stop_dif
	end if
c        write(*,*)jj,start_dif,stop_dif
	end do

95      write(*,*)'Start, Stop Ensembles: ',iens1,iens2
c        
	ifirst=iens1
	ilast=iens2
c
	do jj=1,100000
	if(good)read(19,rec=jj,fmt='(20i3)',err=99)(gdflag(k),k=1,20)
	read(62,rec=jj,fmt='(i8)',err=99)j
	read(61,rec=jj,fmt='(7i5)',err=99)(iday(k),k=1,7)
	day(j)=grejul(iday(1),iday(2),iday(3))
	csec(j)=iday(4)*60*60*100+iday(5)*60*100+iday(6)*100+iday(7)
	ie(j)=j
	ens_day=day(j)+csec(j)/8640000.
	write(76,876,rec=jj)ens_day,rdum,rdum,rdum,rdum
	read(63,rec=jj,fmt='(5f9.2)',err=99)hd(j),dum,rl(j),dum,pt(j)
	read(64,rec=jj,fmt='(f8.2,2f7.0)',err=99)tmp(j),sdum,sv_adcp(j)
	read(65,rec=jj,fmt='(128i8)',err=99)(xv(k),k=1,nbins)
	read(66,rec=jj,fmt='(128i8)',err=99)(yv(k),k=1,nbins)
	read(67,rec=jj,fmt='(128i8)',err=99)(zv(k),k=1,nbins)
	read(68,rec=jj,fmt='(128i8)',err=99)(ev(k),k=1,nbins)
	read(73,rec=jj,fmt='(128i5)',err=99)(pg4(k),k=1,nbins)
	read(69,rec=jj,fmt='(128i5)',err=99)(i1(k),k=1,nbins)
	read(70,rec=jj,fmt='(128i5)',err=99)(i2(k),k=1,nbins)
	read(71,rec=jj,fmt='(128i5)',err=99)(i3(k),k=1,nbins)
	read(72,rec=jj,fmt='(128i5)',err=99)(i4(k),k=1,nbins)
c
	do k=1,nbins
	utemp=xv(k)
	vtemp=yv(k)
	xv(k)=utemp*cos(varmg)+vtemp*sin(varmg)
	yv(k)=vtemp*cos(varmg)-utemp*sin(varmg)
	z(k)=dist_to_first+(k-1)*bin_length
	end do
c
	iflag1(j)=nbins
c
	do l=1,nbins
	ibar(l)=(i1(l)+i2(l)+i3(l)+i4(l))/4.
	end do
c
c        write(12,678)ens_day,(ibar(l),l=1,12)        
678     format(f14.8,12i5)
c
	nbot=nbins
	do l=1,nbins-1
	if( (ibar(l+1)-ibar(l)) .gt. 10.) then 
	nbot=l
	goto 300
	end if
	end do
c
300     nfirst=nbins+1
c
	do l=2,nbins
C       are there 2 in a row above the pg cutoff
	if(pg4(l-1).ge.cut_4pg .and. pg4(l).ge.cut_4pg)then
	nfirst=l-1
	goto 305
	end if
	end do
305     iflag1(j)=nfirst
	nlast=nbins
	do l=nfirst,nbins
C       find last good value
	if(pg4(l).lt.cut_4pg)then
	nlast=l
	goto 310
	end if
	end do
c
310     iflag(j)=min(nbot,nlast)
	if(nfirst.gt.nbins)iflag(j)=1
c
c       write(*,*)j,iflag1(j),iflag(j)
	zbar=0.
	zbar2=0.
	xbar=0.
	xbar2=0.
	ybar=0.
	ybar2=0.
	nzb=0
	if(z(1).gt.0.)then
	do i=1,iflag(j)
	if(.not.good)gdflag(i)=1
	ntt1=ntt1+1
c       find mean vert velocity for all with 100 % good 4 beams
	if(abs(ev(i)).lt.cut_err)ntt2=ntt2+1
	if(pg4(i).gt.cut_4pg .and. abs(ev(i)).lt.cut_err .and.
     :      gdflag(i).eq.1)then
	zbar=zbar+zv(i)
	zbar2=zbar2+zv(i)*zv(i)
	nzb=nzb+1
	xbar=xbar+xv(i)
	xbar2=xbar2+xv(i)*xv(i)
	ybar=ybar+yv(i)
	ybar2=ybar2+yv(i)*yv(i)
	end if
800     format(i5,7f10.1)
	end do
c
	if(nzb.ge.1)then
		zb0=zbar/float(nzb)
		s1=zbar2-zbar*zbar/float(nzb)
		if(s1.ge.0.)then
			szb=sqrt(s1/float(nzb))
		else
			szb=0.
		end if
		xb0=xbar/float(nzb)
		s1=xbar2-xbar*xbar/float(nzb)
		if(s1.ge.0.)then
			sxb=sqrt(s1/float(nzb))
		else
			sxb=0.
		end if
		yb0=ybar/float(nzb)
		s1=ybar2-ybar*ybar/float(nzb)
		if(s1.ge.0.)then
			syb=sqrt(s1/float(nzb))
		else
			syb=0.
		end if
c
c       standard deviation edits on velocities                
c
	zbar=0.
	zbar2=0.
	xbar=0.
	ybar=0.
	nzb1=0
	nxb1=0
	nyb1=0
c
	do i=1,iflag(j)        
	if(.not.good)gdflag(i)=1
	if(pg4(i).gt.cut_4pg .and. abs(ev(i)).lt.cut_err .and.
     :      gdflag(i).eq.1)then
c        
	zdif=abs(zv(i)-zb0)
	if(zdif.lt.(2.*szb))then
	zbar=zbar+zv(i)
	zbar2=zbar2+zv(i)*zv(i)
	nzb1=nzb1+1
	end if
c
	xdif=abs(xv(i)-xb0)
	if(xdif.lt.(2.*sxb))then
	xbar=xbar+xv(i)
	nxb1=nxb1+1
	end if
c               
	ydif=abs(yv(i)-yb0)
	if(ydif.lt.(2.*syb))then
	ybar=ybar+yv(i)
	nyb1=nyb1+1
	end if
c
	end if                
c
	end do
c
	if(nzb1.ne.0)then        
		zb0=zbar/float(nzb1)
		s1=zbar2-zbar*zbar/float(nzb1)
		if(s1.ge.0.)then
				szb=sqrt(s1/float(nzb1))
		else
				szb=0.
		end if
c
	end if
c
	if(nxb1.ne.0)then
	xb0=xbar/float(nxb1)
	end if
	if(nyb1.ne.0)then
	yb0=ybar/float(nyb1)
	end if
c
	if(ifirst.eq.0. .and. nzb1.ge.4)ifirst=ie(j)
	if(ilast.eq.0. .and. nzb1.ge.4)ilast=ie(j)
	if(ie(j).ge.ifirst)then
	if(ie(j).le.ilast)then
	nj=nj+1
	vl0(nj)=day(j)+csec(j)/8640000.
c                
	if(zb0.gt.0)zb0=zb0*zfacdn
	if(zb0.lt.0)zb0=zb0*zfacup
	il5(nj)=ie(j)
	vl1(nj)=zb0
	vl2(nj)=xb0
	vl3(nj)=yb0
	zflag(nj)=1
	if(szb.le.cut_z_std)zflag(nj)=0
c	type *,nj,szb
	xflag(nj)=0
	yflag(nj)=0
c        
	end if
	end if
c
	else
c
	end if
c
	end if        
c
	end do

99      write(*,*)nj,' Good ensembles  '
c
	write(14,rec=6,fmt='(i8,3f12.5)')ifirst,vl0(1),y1,x1
	write(14,rec=7,fmt='(i8,3f12.5)')ilast,vl0(nj),y2,x2
	write(14,rec=8,fmt='(f8.1,2f8.4)')cdep,zfacdn,zfacup
c
c       find outliers in mean u,v,w fields
c
	do i=4,nj-3
c
	xt1=0.
	xt2=0.
	yt1=0.
	yt2=0.
	nx=0
	ny=0
c
	do j=i-3,i+3
c
	if(xflag(j).eq.0)then
	xt1=xt1+vl2(j)
	xt2=xt2+vl2(j)*vl2(j)
	nx=nx+1
	end if
c
	if(yflag(j).eq.0)then
	yt1=yt1+vl3(j)
	yt2=yt2+vl3(j)*vl3(j)
	ny=ny+1
	end if
c
	end do
c
	tt0=(vl0(i+3)-vl0(i-3))*86400.
c
	if(nx.ne.0)then
	xt2=xt2-xt1*xt1/nx
	if(xt2.ge.0.)then
		xt2=sqrt(xt2/nx)
	else
	xt2=0.
	end if
	xt1=xt1/nx
	end if
	if(ny.ne.0)then
	yt2=yt2-yt1*yt1/ny
	if(yt2.ge.0.)then
		yt2=sqrt(yt2/ny)
	else
		yt2=0.
	end if
	yt1=yt1/ny
	end if
c
	do j=i-3,i+3
	xdf=vl2(j)-xt1
	ydf=vl3(j)-yt1
	if(abs(xdf).gt. (2.*xt2)) xflag(j)=1
	if(abs(ydf).gt. (2.*yt2)) yflag(j)=1
	end do
c
	end do
c                       
	do i=4,nj-3
c
	xt1=0.
	yt1=0.
	zt1=0.
	nx=0
	ny=0
	nz=0
c
	do j=i-3,i+3
c
	if(xflag(j).eq.0)then
	xt1=xt1+vl2(j)
	nx=nx+1
	end if
c
	if(yflag(j).eq.0)then
	yt1=yt1+vl3(j)
	ny=ny+1
	end if
c
	if(zflag(j).eq.0)then
	zt1=zt1+vl1(j)
	nz=nz+1
	end if
c         
	end do
c
	if(nx.ne.0)then
	xrep=xt1/float(nx)
	else
	xrep=0.
	end if
c
	if(ny.ne.0)then
	yrep=yt1/float(ny)
	else
	yrep=0.
	end if
c
	if(nz.ne.0)then
	zrep=zt1/float(nz)
	else
	zrep=0.
	end if
c
c        if(zflag(i).eq.1)vl1(i)=zrep
	if(xflag(i).eq.1)vl2(i)=xrep
	if(yflag(i).eq.1)vl3(i)=yrep
c
	end do
c
	write(*,*)'Ev criteria initially accepted ',ntt2,' of ',ntt1
c
	znet=0.
	xnet=0.
	ynet=0.
	do i=2,nj
	sec=(vl0(i)-vl0(i-1))*86400.
	svapp=svel(znet,tmp(il5(i)),35.0)
	sv_used=sv_adcp(il5(i))
c
	zbbr=(svapp/sv_used)*(vl1(i)+vl1(i-1))/2000.
	znet=znet+sec*zbbr
	if(i.eq.2)zfirst=znet
	if(i.eq.nj)zlast=znet
	depth(i)=znet
c        
	if(znet.gt.zmax)then
	zmax=znet
	izmax=il5(i)
	botmax=i
	end if
c
	xnet=xnet+(svapp/sv_used)*sec*(vl2(i)+vl2(i-1))/2000.
	ynet=ynet+(svapp/sv_used)*sec*(vl3(i)+vl3(i-1))/2000.
c
	x_uncor=(svapp/sv_used)*(vl2(i)+vl2(i-1))/20.
	y_uncor=(svapp/sv_used)*(vl3(i)+vl3(i-1))/20.
	utemp=x_uncor
	vtemp=y_uncor
	varcor=-varmg
	u_ctd=utemp*cos(varcor)+vtemp*sin(varcor)
	v_ctd=vtemp*cos(varcor)-utemp*sin(varcor)
	write(76,876,rec=il5(i))vl0(i),znet,u_ctd,v_ctd,zbbr*100.
876     format(f12.5,4f7.1)
	end do
c        
	topdif=abs(zlast)
	botdif=abs(zmax-cdep)
	write(*,742)zfirst,zmax,zlast
	write(*,743)zfacdn,zfacup
742     format('Start Depth ',f7.0,'  Bottom Depth ',f7.0,        
     :   '  Finish Depth ',f7.0)
743     format('Vertical velocity factors: Down ',f8.5,'  up ',f8.5)
	if(topdif.gt.2. .or. botdif.gt.2.)then
	zfacdn=zfacdn/(zmax/cdep)
	zfacup=zfacup/((zmax-zlast)/cdep)
	goto 1111
	end if
c
	open(unit=9,file=iname,form='formatted',status='unknown')
c
	write(9,'(a)')fname
c
	write(9,*)start_jd,start_hr,start_min,start_sec
	write(9,811)iy1,ry1,ns1
	write(9,811)ix1,rx1,ew1
	write(9,*)stop_jd,stop_hr,stop_min,stop_sec
	write(9,811)iy2,ry2,ns2
	write(9,811)ix2,rx2,ew2
c
	write(9,841)cdep,ifirst,ilast
	write(9,842)zfacdn
	write(9,842)zfacup
	write(9,843)varmg/0.017453293
841     format(f9.0,2i9)
842     format(f14.8)
843     format(f9.1)
c
	close(9)
c
	recl=nbins * 5 + 2
	open(unit=36,file='i1.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=37,file='i2.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=38,file='i3.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=39,file='i4.out',status='old',readonly,
     :   access='direct',form='formatted')
c
	idbot=max(botmax-300,2)
	iubot=min(botmax+300,nj)
	estbot=depth(idbot)
	kk=0
	do i=idbot,iubot
	kk=kk+1
c
	jj=il5(i)
c
	read(69,rec=jj,fmt='(128i5)',err=99)(i1(k),k=1,nbins)
	read(70,rec=jj,fmt='(128i5)',err=99)(i2(k),k=1,nbins)
	read(71,rec=jj,fmt='(128i5)',err=99)(i3(k),k=1,nbins)
	read(72,rec=jj,fmt='(128i5)',err=99)(i4(k),k=1,nbins)
c
	do l=1,nbins
	bfind(kk,l)=(i1(l)+i2(l)+i3(l)+i4(l))/4.
	end do

	end do
c
	do i=1,bin_dim
	botinten(i)=0
	do ii=1,kk
	 if(bfind(ii,i).gt.botinten(i))then
		botbin(i)=ii
	        botinten(i)=bfind(ii,i)
	 end if
	end do
	end do
c
	botav=cbot
	nbotav=0
	do i=1,bin_dim
	ikk=idbot+botbin(i)-1
	thisbot=depth(ikk)+(dist_to_first+(i-1)*bin_length)/100.
c	bthresh=175-i*5
	bthresh=195-i*5
	type *,i,botinten(i),bthresh,thisbot
	if(botinten(i).ge.bthresh)then
		botav=max(botav,thisbot)
		nbotav=nbotav+1
	end if
	end do
c
	if(nbotav.gt.0)then
c		botav=botav/float(nbotav)
	type *,' Estimated bottom depth ',botav
	else
	type *,botmax,depth(botmax),dist_to_first,nbins,bin_length
c
	botav=depth(botmax)+(dist_to_first+(nbins-1)*
     :              bin_length)/100.
	type *,' Estimated bottom depth at least ',botav
	end if

	botav=max(botav,cdep)
c
	zlbin=botav
c
c
	if(.not.good)then
		close(76)
		call gflag
		good=.true.
		goto 48
	end if
c
	do i=1,nj
c
	j=il5(i)
c
	if(j.ge.ifirst .and. j.le.ilast)then
c       
	read(63,rec=j,fmt='(5f9.2)',err=74)hhh,dum,rll,dum,ptt
c
	call wake(hhh,rll,ptt,vl1(i),vl2(i),vl3(i),wake_correct)
c
74      read(65,rec=j,fmt='(128i8)',err=72)(xv(k),k=1,nbins)
	read(66,rec=j,fmt='(128i8)')(yv(k),k=1,nbins)
	read(67,rec=j,fmt='(128i8)')(zv(k),k=1,nbins)
	read(68,rec=j,fmt='(128i8)')(ev(k),k=1,nbins)
	read(73,rec=j,fmt='(128i5)')(pg4(k),k=1,nbins)
	read(19,rec=j,fmt='(20i3)',err=99)(gdflag(k),k=1,20)
c	type *,gdflag(8)
c
	svapp=svel(depth(i),tmp(il5(i)),35.0)
	sv_used=sv_adcp(il5(i))
	svratio=(svapp/sv_used)
c
	do k=1,nbins
	utemp=xv(k)*svratio
	vtemp=yv(k)*svratio
	xv(k)=utemp*cos(varmg)+vtemp*sin(varmg)
	yv(k)=vtemp*cos(varmg)-utemp*sin(varmg)
	z(k)=dist_to_first+(k-1)*bin_length*1500./svapp
	end do
c
	z0=depth(i) 
c
	if(iflag(j).gt.0 .and. xflag(i).eq.0 .and. yflag(i).eq.0
     :  .and. wake_correct.eq.0)then
	nsh=0
	do k=iflag1(j),iflag(j)
c	if(.not.good)gdflag(k)=1
	if(pg4(k).gt.cut_4pg .and. abs(ev(k)).lt.cut_err .and. 
     :      gdflag(k).eq.1)then
	shtest=z0+z(k)/100.
	if(shtest.lt.zlbin)then
	nsh=nsh+1
	shd(nsh)=shtest
	shx(nsh)=xv(k)-vl2(i)
	shy(nsh)=yv(k)-vl3(i)
	lbin(nsh)=k
	end if
	end if
c
	end do
c
	do k=1,nsh
	nshear=nshear+1
	z1(nshear)=shd(k)   !x0
	u1(nshear)=shx(k)   !u4
	v1(nshear)=shy(k)   !v4
	e1(nshear)=lbin(k)
	ie1(nshear)=j
	ir1(nshear)=nshear
c       
	end do
c
	end if
c
	end if
c
	end do  
c
72      do i=1,zlbin+9,16
	zbd2=float(i)
	zbd1=zbd2-16.
c
	usm0=0.
	usm1=0.
	vsm0=0.
	vsm1=0.
	nsm=0
	do j=1,nshear
	if(z1(j).ge.zbd1 .and. z1(j).lt.zbd2)then
	nsm=nsm+1
	usm0=usm0+u1(j)
	vsm0=vsm0+v1(j)
	usm1=usm1+u1(j)*u1(j)
	vsm1=vsm1+v1(j)*v1(j)
	end if
	end do
c
	usmn=0.
	vsmn=0.
	if(nsm.ne.0)then
	usmn=usm0/nsm
	vsmn=vsm0/nsm
	usq=(usm1-usm0*usm0/nsm)
	vsq=(vsm1-vsm0*vsm0/nsm)
	if(usq.gt.0.)then
	ussd=sqrt(usq/nsm)
		else
	ussd=0.
	end if
c
	if(vsq.gt.0.)then
	vssd=sqrt(vsq/nsm)
		else
	vssd=0.
	end if
	end if
c
	nubad=0
	nvbad=0
	do j=1,nshear
	if(z1(j).ge.zbd1 .and. z1(j).lt.zbd2)then
	ur1=usmn-2.*ussd
	ur2=usmn+2.*ussd
	if(u1(j).lt.ur1 .or. u1(j).gt.ur2)then
		uflag(ie1(j),e1(j))=0        !0 is bad data
		nubad=nubad+1
	else
		uflag(ie1(j),e1(j))=1           !  1 is good data
	end if
c
	vr1=vsmn-2.*vssd
	vr2=vsmn+2.*vssd
	if(v1(j).lt.vr1 .or. v1(j).gt.vr2)then
		vflag(ie1(j),e1(j))=0        !0 is bad data
		nvbad=nvbad+1
	else
		vflag(ie1(j),e1(j))=1           !  1 is good data
	end if
c
	end if
	end do
	end do
c
	nshear=0        
	zlbin=botav
c
	do i=1,nj
c
	j=il5(i)
c
	read(63,rec=j,fmt='(5f9.2)',err=83)hhh,dum,rll,dum,ptt
c
	call wake(hhh,rll,ptt,vl1(i),vl2(i),vl3(i),wake_correct)
c
83      read(65,rec=j,fmt='(128i8)',err=75)(xv(k),k=1,nbins)
	read(66,rec=j,fmt='(128i8)')(yv(k),k=1,nbins)
	read(67,rec=j,fmt='(128i8)')(zv(k),k=1,nbins)
	read(68,rec=j,fmt='(128i8)')(ev(k),k=1,nbins)
	read(73,rec=j,fmt='(128i5)')(pg4(k),k=1,nbins)
	read(19,rec=j,fmt='(20i3)',err=99)(gdflag(k),k=1,20)

	svapp=svel(depth(i),tmp(il5(i)),35.0)
	sv_used=sv_adcp(il5(i))
	svratio=(svapp/sv_used)
c
	do k=1,nbins
	utemp=xv(k)*svratio
	vtemp=yv(k)*svratio
	xv(k)=utemp*cos(varmg)+vtemp*sin(varmg)
	yv(k)=vtemp*cos(varmg)-utemp*sin(varmg)
	z(k)=dist_to_first+(k-1)*bin_length*1500./svapp
	end do
c
	z0=depth(i) 
c
	if(iflag(j).gt.2 .and. xflag(i).eq.0 .and. yflag(i).eq.0
     :  .and. wake_correct.eq.0)then
	nsh=0
	do k=iflag1(j)+1,iflag(j)
c	if(.not.good)then
c		gdflag(k)=1
c		gdflag(k-1)=1
c	end if
c	type *,pg4(k),pg4(k-1),ev(k),ev(k-1),gdflag(k),gdflag(k-1)
	if(pg4(k).gt.cut_4pg .and. pg4(k-1).gt.cut_4pg .and.
     :  abs(ev(k)).lt.cut_err .and. abs(ev(k-1)).lt.cut_err
     :  .and. gdflag(k).eq.1 .and. gdflag(k-1).eq.1)then
	shtest=z0+(z(k-1)+z(k))/200.
	if(uflag(j,k).eq.1 .and. uflag(j,k-1).eq.1 .and.
     :  vflag(j,k).eq.1 .and. vflag(j,k-1).eq.1) then
	if(shtest.lt.zlbin)then
	nsh=nsh+1
	shd(nsh)=z0+(z(k-1)+z(k))/200.
	shx(nsh)=1000.*float(xv(k)-xv(k-1))/(z(k)-z(k-1))
	shy(nsh)=1000.*float(yv(k)-yv(k-1))/(z(k)-z(k-1))
	shz(nsh)=1000.*float(zv(k)-zv(k-1))/(z(k)-z(k-1))
	shpg(nsh)=min(pg4(k),pg4(k-1))
	she(nsh)=max(abs(ev(k)),abs(ev(k-1)))
	end if
	end if
	end if
c
	end do
c
	do k=1,nsh
	nshear=nshear+1
	z1(nshear)=shd(k)   !x0
	u1(nshear)=shx(k)   !u4
	v1(nshear)=shy(k)   !v4
	w1(nshear)=shz(k)
	p1(nshear)=shpg(k)   !v4
	e1(nshear)=she(k)
	ie1(nshear)=j
	ir1(nshear)=nshear
	end do
c
	end if
c
	end do  

75      type *,nshear
	CALL VSRTR (z1,nshear,ir1)
c
	do i=1,nshear
	nr=ir1(i)
	tmp1(i)=u1(nr)
	end do
	do i=1,nshear
	u1(i)=tmp1(i)
	end do
c
	do i=1,nshear
	nr=ir1(i)
	tmp1(i)=v1(nr)
	end do
	do i=1,nshear
	v1(i)=tmp1(i)
	end do
c
	do i=1,nshear
	nr=ir1(i)
	tmp1(i)=w1(nr)
	end do
	do i=1,nshear
	w1(i)=tmp1(i)
	end do
c
c	do i=1,nshear
c	nr=ir1(i)
c	tmp1(i)=p1(nr)
c	end do
c	do i=1,nshear
c	p1(i)=tmp1(i)
c	end do
c
	do i=1,nshear
	nr=ir1(i)
	tmp1(i)=e1(nr)
	end do
	do i=1,nshear
	e1(i)=tmp1(i)
	end do
c
	do i=1,nshear
	nr=ir1(i)
	tmp1(i)=ie1(nr)
	end do
c
	do i=1,nshear
	ie1(i)=tmp1(i)
	ir1(i)=0		! bottom refl flag for u shears
	p1(i)=0		        ! bottom refl flag for v shears
	end do
c
	open(unit=77,file='shears.out',status='new',
     :   recl=50,form='formatted')
c
c       try to smooth out bottom reflection
c
	ubr=0.
	ubr2=0.
	nubr=0
	vbr=0.
	vbr2=0.
	nvbr=0
	brefl1=cdep-400.
	brefl2=cdep-1000.
	brefl3=cdep-500
	brefl4=cdep-900
c
	if(brefl2.gt.50.)then
c
	do i=1,nshear                
	if( (z1(i).lt.brefl1 .and. z1(i).gt.brefl3) .or.
     :	(z1(i).lt.brefl4 .and. z1(i).gt.brefl2) )then
	ubr=ubr+u1(i)
	ubr2=ubr2+u1(i)*u1(i)
	nubr=nubr+1
	vbr=vbr+v1(i)
	vbr2=vbr2+v1(i)*v1(i)
	nvbr=nvbr+1
	end if
	end do
c
	ubstd=sqrt( (ubr2-ubr*ubr/float(nubr))/float(nubr) )
	ubmean=ubr/float(nubr)
	vbstd=sqrt( (vbr2-vbr*vbr/float(nvbr))/float(nvbr) )
	vbmean=vbr/float(nvbr)
c
	do i=1,nshear
	if(z1(i).lt.brefl3 .and. z1(i).gt.brefl4)then
	if(u1(i).lt.(-1.*ubstd) .or. u1(i).gt.
     :     (1.*ubstd))ir1(i)=1   !u1(i)=.9*ubmean+.1*u1(i)   
	if(v1(i).lt.(-1.*vbstd) .or. v1(i).gt.
     :     (1.*ubstd))p1(i)=1    !v1(i)=.9*vbmean+.1*v1(i)   
c      write(*,631)z1(i),ir1(i),ubmean-1.5*ubstd,u1(i),ubmean+1.5*ubstd
631     format(f10.1,i4,3f10.1)
	end if
	end do
c
	end if
c
	do i=1,nshear
	if(ir1(i).eq.0 .and. p1(i).eq.0)then
	write(77,877)z1(i),u1(i),v1(i),w1(i),ie1(i),e1(i)
877     format(4f8.1,2i7)
	end if
	end do
c
	deltim=(vl0(nj)-vl0(1))*86400.
	write(*,*)'Total Time ',deltim/60.,' Minutes'
c        
	call geodinv (y1,x1,y2,x2,dst,az1,az2)
	az1=(90.-az1)*.017453293
	xdst=dst*cos(az1)
	ydst=dst*sin(az1)
	bx=xdst*100/deltim
	by=ydst*100/deltim
c
	cx=xnet*100/deltim
	cy=ynet*100/deltim
c
	write(*,*)nshear,'  Shear values'
	write(*,*)' Max profiler depth at ensemble ',izmax,zmax
	write(*,*)'Start depth ',zfirst,'   Final depth ',zlast
	write(14,rec=9,fmt='(3f8.1)')zfirst,zmax,zlast
	write(14,rec=10,fmt='(i8,f12.5)')izmax,vl0(izmax)
	write(14,rec=11,fmt='(f8.1)')varmg/.017453293
	write(14,rec=12,fmt='(2f8.2)')bx,by
	write(14,rec=13,fmt='(2f8.2)')cx,cy
c
	stop
	end
c
	subroutine geodinv (la1,lo1,la2,lo2,dist,azf,azb)
c
c quick geodetic inverse based on NOAA NOS Tech Rep NOS 81 (J Collins)
c lat,lon are in decimal degrees with S,W negative
c dist is returned in meters, azimuths in true degrees 0-360
c
	implicit real*8 (a-m,o-z)       ! only integers are n's
c
c       a=6378206.4   !6378163.  ! alternate values
c       b=6356583.8   !6356177.  ! alternate values
	a=6378135.0   !wgs-72
	b=6356750.5   !wgs-72
c
	if(la1.eq.la2 .and. lo1.eq.lo2)then
		dist=0.
		azb=0.
		azf=0.
		return
	end if
c
	conv = 3.141592654 / 180.
	e0 = a*a - b*b          ! some eccentricities, not all of which
	e1 = e0 / (a*a)         ! are used.
	e2 = e0 / (b*b)
	e3 = e0 / (a*a + b*b)
	e4 = e0 / (a*b)
c
	lat1=la1*conv
	lon1=lo1*conv
	lat2=la2*conv
	lon2=lo2*conv
	dlon=lon2-lon1
c
	tanpsi1 =  b*b * tan(lat1) / (a*a)         ! geocentric lats
	tanpsi2 =  b*b * tan(lat2) / (a*a)
c
	psi1 = atan(tanpsi1)
	psi2 = atan(tanpsi2)
c
	azf = atan2 ( sin(dlon) ,                  !      fwd azimuth
     :        ( tanpsi2 - tanpsi1*cos(dlon) ) * cos(psi1) )
c
	azb = atan2 ( sin(-dlon) ,                 !      back azimuth
     :        ( tanpsi1 - tanpsi2*cos(-dlon) ) * cos(psi2) )
c
	theta1 = atan2(cos(azf),tanpsi1)
	theta2 = atan2(cos(azb),tanpsi2)
c
	beta0 = atan2 ( a * sqrt( tanpsi1*tanpsi1 +
     :          tanpsi2*tanpsi2 - 2.*tanpsi1*tanpsi2*
     :          cos(dlon) ) , b * sin(dlon) )
c
	bbar = b * sqrt ( 1. + e2 * cos(beta0)*cos(beta0) )
	mbar = (a*a - bbar*bbar) / (a*a + bbar*bbar)
c
	rad0 = sqrt ( .5 * (a*a+bbar*bbar) ) * ( 1. - mbar*mbar/16.)
	biga = mbar / 4. + 21.*mbar*mbar*mbar / 128.
	bigb = mbar*mbar / 64.
c
	s1=rad0*(theta1-biga*sin(2.*theta1)+bigb*sin(4.*theta1))
	s2=rad0*(theta2-biga*sin(2.*theta2)+bigb*sin(4.*theta2))
c
	dist = s1 + s2
	azf=azf/conv
	azb=azb/conv
	if(azf.lt.0.)azf=azf+360.
	if(azb.lt.0.)azb=azb+360.
c
	return
	end
c
      SUBROUTINE VSRTR  (A,LA,IR)                                      
c
      integer*4 la
      INTEGER*4            IR(LA)                                     
      REAL*4               A(LA)                                         
c
      INTEGER            IU(21),IL(21),I,M,J,K,IJ,IT,L,ITT             
      REAL               T,TT,R                                        
c
      IF (LA.LE.0) goto 999                                               
      M = 1                                                             
      I = 1                                                             
      J = LA                                                            
      R = .375                                                          
    5 IF (I.EQ.J) GO TO 45                                              
      IF (R.GT..5898437) GO TO 10                                       
      R = R+3.90625E-2                                                  
      GO TO 15                                                          
   10 R = R-.21875                                                      
   15 K = I                                                             
c
      IJ = I+(J-I)*R                                                    
      T = A(IJ)                                                         
      IT = IR(IJ)                                                       
c
      IF (A(I).LE.T) GO TO 20                                           
      A(IJ) = A(I)                                                      
      A(I) = T                                                          
      T = A(IJ)                                                         
      IR(IJ) = IR(I)                                                    
      IR(I) = IT                                                        
      IT = IR(IJ)                                                       
   20 L = J                                                             
c
      IF (A(J).GE.T) GO TO 30                                           
      A(IJ) = A(J)                                                      
      A(J) = T                                                          
      T = A(IJ)                                                         
      IR(IJ) = IR(J)                                                    
      IR(J) = IT                                                        
      IT = IR(IJ)                                                       
c
      IF (A(I).LE.T) GO TO 30                                           
      A(IJ) = A(I)                                                      
      A(I) = T                                                          
      T = A(IJ)                                                         
      IR(IJ) = IR(I)                                                    
      IR(I) = IT                                                        
      IT = IR(IJ)                                                       
      GO TO 30                                                          
   25 IF (A(L).EQ.A(K)) GO TO 30                                        
      TT = A(L)                                                         
      A(L) = A(K)                                                       
      A(K) = TT                                                         
      ITT = IR(L)                                                       
      IR(L) = IR(K)                                                     
      IR(K) = ITT                                                       
c
   30 L = L-1                                                           
      IF (A(L).GT.T) GO TO 30                                           
c
   35 K = K+1                                                           
      IF (A(K).LT.T) GO TO 35                                           
c
      IF (K.LE.L) GO TO 25                                              
c
      IF (L-I.LE.J-K) GO TO 40                                          
      IL(M) = I                                                         
      IU(M) = L                                                         
      I = K                                                             
      M = M+1                                                           
      GO TO 50                                                          
   40 IL(M) = K                                                         
      IU(M) = J                                                         
      J = L                                                             
      M = M+1                                                           
      GO TO 50                                                          
c
   45 M = M-1                                                           
      IF (M.EQ.0) RETURN                                                
      I = IL(M)                                                         
      J = IU(M)                                                         
   50 IF (J-I.GE.11) GO TO 15                                           
      IF (I.EQ.1) GO TO 5                                               
      I = I-1                                                           
   55 I = I+1                                                           
      IF (I.EQ.J) GO TO 45                                              
      T = A(I+1)                                                        
      IT = IR(I+1)                                                      
      IF (A(I).LE.T) GO TO 55                                           
      K = I                                                             
   60 A(K+1) = A(K)                                                     
      IR(K+1) = IR(K)                                                   
      K = K-1                                                           
      IF (T.LT.A(K)) GO TO 60                                           
      A(K+1) = T                                                        
      IR(K+1) = IT                                                      
      GO TO 55                                                          
c
999     return
	END                                                               
c
	FUNCTION GREJUL(IYEAR,IMONTH,IDAY)
	INTEGER*4 DAYS(12,2)
	integer*4 grejul,iyear,imonth,iday
	DATA DAYS/0,31,59,90,120,151,181,212,243,273,304,
     *  334,0,31,60,91,121,152,182,213,244,274,305,335/
	
C       ASSUME NOT A LEAP YEAR
	I=1
C       CHECK FOR A LEAP YEAR
	IF(MOD(IYEAR,4).EQ.0)I=2
C       COMPUTE JULIAN DATE
	GREJUL=IDAY + DAYS(IMONTH,I) 
	RETURN
	END
c
	subroutine wake(head,roll,pitch,z,x,y,wc)
	integer*2 wc
c
	ww=10.
	nww=10
	wc=0
c
	if(x.ne.0.)then
		hang=90.-atan2(y,x)/0.017453293
	else
		hang=90.
	end if
	hmag=sqrt(x*x+y*y)
	vang=atan2(z,hmag)/0.017453293
	if (abs(head-hang).lt.ww)wc=3
	if(abs(mod(int(90.+head),360)-hang).lt.ww)wc=2
	if(abs(mod(int(180.+head),360)-hang).lt.ww)wc=4
	if(abs(mod(int(270.+head),360)-hang).lt.ww)wc=1
c
	if(wc.eq.3)vang=vang+pitch
	if(wc.eq.2)vang=vang+roll
	if(wc.eq.4)vang=vang-pitch
	if(wc.eq.1)vang=vang-roll
	ivdif=abs(30.+vang)
	if(ivdif.gt.nww)wc=0
c
	return
	end
c
	function svel(pr,t,sal)
c
	p=0.1019716*(pr+10.1325)
	sd=sal-35.
	a=(((7.9851e-6*t-2.6045e-4)*t-4.4532e-2)*t+4.5721)*t+1449.14
	svel=(7.7711e-7*t-1.1244e-2)*t+1.39799
	v0=(1.69202e-3*sd+svel)*sd+a
	a=((4.5283e-8*t+7.4812e-6)*t-1.8607e-4)*t+0.160272
	svel=(1.579e-9*t+3.158e-8)*t+7.7016e-5
	v1=svel*sd+a
	a=(1.8563e-9*t-2.5294e-7)*t+1.0268e-5
	svel=-1.2943e-7*sd+a
	a=-1.9646e-10*t+3.5216e-9
	svel=(((-3.3603e-12*p+a)*p+svel)*p+v1)*p+v0
	return
	end
c
	subroutine gflag
c
	parameter (nz=20000,nx=25)
c
	real*4 		z(nz)
	integer*4	inn(nx,nz),cor(nx,nz)
	integer*2	i1(nx),i2(nx),i3(nx),i4(nx)
	integer*2	c1(nx),c2(nx),c3(nx),c4(nx)
	real*4 		ibar(20,200),cbar(20,200),zbar(200)
	real*8 		isum2(20,200),csum2(20,200)
	real*4 		isum(20,200),csum(20,200)
	real*4 		istd(20,200),cstd(20,200)
	integer*4 	inbar(20,200),cnbar(20,200)
	integer*2	gdflag(nx,nz)
c
	nbins=20
c
c
	open(unit=31,file='vels.out',status='unknown',
     :   access='direct',recl=40,form='formatted')
c
	recl=nbins * 5 + 2
	open(unit=32,file='c1.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=33,file='c2.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=34,file='c3.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=35,file='c4.out',status='old',readonly,
     :   access='direct',form='formatted')
C
	open(unit=36,file='i1.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=37,file='i2.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=38,file='i3.out',status='old',readonly,
     :   access='direct',form='formatted')
	open(unit=39,file='i4.out',status='old',readonly,
     :   access='direct',form='formatted')
c
	do i=1,nz
c
	read(unit=36,fmt=800,rec=i,err=99)(i1(j),j=1,20)
	read(unit=37,rec=i,fmt=800)(i2(j),j=1,20)
	read(unit=38,rec=i,fmt=800)(i3(j),j=1,20)
	read(unit=39,rec=i,fmt=800)(i4(j),j=1,20)
c
	read(unit=32,rec=i,fmt=800)(c1(j),j=1,20)
	read(unit=33,rec=i,fmt=800)(c2(j),j=1,20)
	read(unit=34,rec=i,fmt=800)(c3(j),j=1,20)
	read(unit=35,rec=i,fmt=800)(c4(j),j=1,20)
c
800	format(128i5)
c
876     format(f12.5,f7.1)
c
	do j=1,20
	inn(j,i)=(i1(j)+i2(j)+i3(j)+i4(j))/4
	end do
c
	do j=1,20
	if(c1(j).ne.0 .and. c2(j).ne.0 .and. c3(j).ne.0 .and.
     :       c4(j).ne.0)then
	cor(j,i)=(c1(j)+c2(j)+c3(j)+c4(j))/4
	else
	cor(j,i)=0
	end if
	end do
c
	read(unit=31,rec=i,fmt=876)dum,z(i)
c
c	type *,z(i),inn(2,i),cor(2,i)
c
	if(z(i).gt.0. .and. z(i).lt.2500.)then
	iz=int(z(i)/20.)+1
	zbar(iz)=iz*20.-10.
	else
	iz=126
	end if
c
	do j=1,20
	if(iz.ne.0)then
	if(inn(j,i).ge.30.)then
	isum(j,iz)=isum(j,iz)+inn(j,i)
	isum2(j,iz)=isum2(j,iz)+inn(j,i)*inn(j,i)
	inbar(j,iz)=inbar(j,iz)+1
	end if
	if(cor(j,i).ge.50.)then
		csum(j,iz)=csum(j,iz)+cor(j,i)
		csum2(j,iz)=csum2(j,iz)+cor(j,i)*cor(j,i)
		cnbar(j,iz)=cnbar(j,iz)+1
	end if
	end if
c
	end do
c
	end do
c
99	do j=1,20
	do i=1,126
c	
	if(inbar(j,i).ne.0)then
		tmp=isum2(j,i)-isum(j,i)*isum(j,i)/float(inbar(j,i))
		if(tmp.gt.0.)then
		   istd(j,i)=sqrt(tmp/float(inbar(j,i)))
		else
		   istd(j,i)=0.
		end if
		ibar(j,i)=isum(j,i)/float(inbar(j,i))
	end if
c
	if(cnbar(j,i).ne.0)then
		tmp=csum2(j,i)-csum(j,i)*csum(j,i)/float(cnbar(j,i))
		if(tmp.gt.0.)then
		   cstd(j,i)=sqrt(tmp/float(cnbar(j,i)))
		else
		   cstd(j,i)=0.
		end if
		cbar(j,i)=csum(j,i)/float(cnbar(j,i))
	end if
c
c	type 850,i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
c	write(18,850)i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
850	format(2i7,5f10.2)
c
	end do
	end do
c
	do j=1,20
	do k=1,200
	isum(j,k)=0.
	isum2(j,k)=0.
	csum(j,k)=0.
	csum2(j,k)=0.
	cnbar(j,k)=0.
	inbar(j,k)=0.
	end do
	end do
c
	do i=1,nz
c
	if(z(i).gt.0. .and. z(i).lt.2500.)then
	iz=int(z(i)/20.)+1
	zbar(iz)=iz*20.-10.
	else
	iz=126
	end if
c
	do j=1,20
c
	if(iz.lt.126)then
	id1=ibar(j,iz)-3.*istd(j,iz)
	id2=ibar(j,iz)+3.*istd(j,iz)
	cd1=cbar(j,iz)-3.*cstd(j,iz)
	cd2=cbar(j,iz)+3.*cstd(j,iz)
	else
	id1=ibar(j,iz)-3.*istd(j,iz)
	id2=ibar(j,iz)+istd(j,iz)
	cd1=cbar(j,iz)-10.*cstd(j,iz)
	cd2=cbar(j,iz)+cstd(j,iz)
	end if
c
	if(inn(j,i).ge.30.)then
	if(iz.ne.0 .and. inn(j,i).lt.id2 .and. inn(j,i).gt.id1)then
	isum(j,iz)=isum(j,iz)+inn(j,i)
	isum2(j,iz)=isum2(j,iz)+inn(j,i)*inn(j,i)
	inbar(j,iz)=inbar(j,iz)+1
	end if
	end if
c
	if(cor(j,i).ge.50.)then
	if(iz.ne.0 .and. cor(j,i).lt.cd2 .and. cor(j,i).gt.cd1)then
		csum(j,iz)=csum(j,iz)+cor(j,i)
		csum2(j,iz)=csum2(j,iz)+cor(j,i)*cor(j,i)
		cnbar(j,iz)=cnbar(j,iz)+1
	end if
	end if
c
	end do
c
	end do
c
	do j=1,20
	do i=1,126
c	
	if(inbar(j,i).ne.0)then
		tmp=isum2(j,i)-isum(j,i)*isum(j,i)/float(inbar(j,i))
		if(tmp.gt.0.)then
		   istd(j,i)=sqrt(tmp/float(inbar(j,i)))
		else
		   istd(j,i)=0.
		end if
		ibar(j,i)=isum(j,i)/float(inbar(j,i))
	end if
c
	if(cnbar(j,i).ne.0)then
		tmp=csum2(j,i)-csum(j,i)*csum(j,i)/float(cnbar(j,i))
		if(tmp.gt.0.)then
		   cstd(j,i)=sqrt(tmp/float(cnbar(j,i)))
		else
		   cstd(j,i)=0.
		end if
		cbar(j,i)=csum(j,i)/float(cnbar(j,i))
	end if
c
c	type 850,i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
c	write(18,850)i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
c
	end do
	end do
c
	do j=1,20
	do k=1,200
	isum(j,k)=0.
	isum2(j,k)=0.
	csum(j,k)=0.
	csum2(j,k)=0.
	cnbar(j,k)=0.
	inbar(j,k)=0.
	end do
	end do
c
	do i=1,nz
c
	if(z(i).gt.0. .and. z(i).lt.2500.)then
	iz=int(z(i)/20.)+1
	zbar(iz)=iz*20.-10.
	else
	iz=126
	end if
c
	do j=1,20
c
	if(iz.lt.126)then
	id1=ibar(j,iz)-3.*istd(j,iz)
	id2=ibar(j,iz)+3.*istd(j,iz)
	cd1=cbar(j,iz)-3.*cstd(j,iz)
	cd2=cbar(j,iz)+3.*cstd(j,iz)
	else
	id1=ibar(j,iz)-3.*istd(j,iz)
	id2=ibar(j,iz)+istd(j,iz)
	cd1=cbar(j,iz)-10.*cstd(j,iz)
	cd2=cbar(j,iz)+cstd(j,iz)
	end if
c
	if(inn(j,i).ge.30.)then
	if(iz.ne.0 .and. inn(j,i).lt.id2 .and. inn(j,i).gt.id1)then
	isum(j,iz)=isum(j,iz)+inn(j,i)
	isum2(j,iz)=isum2(j,iz)+inn(j,i)*inn(j,i)
	inbar(j,iz)=inbar(j,iz)+1
	end if
	end if
c
	if(cor(j,i).ge.50.)then
	if(iz.ne.0 .and. cor(j,i).lt.cd2 .and. cor(j,i).gt.cd1)then
		csum(j,iz)=csum(j,iz)+cor(j,i)
		csum2(j,iz)=csum2(j,iz)+cor(j,i)*cor(j,i)
		cnbar(j,iz)=cnbar(j,iz)+1
	end if
	end if
c
	end do
c
	end do
c
	do j=1,20
	do i=1,126
c	
	if(inbar(j,i).ne.0)then
		tmp=isum2(j,i)-isum(j,i)*isum(j,i)/float(inbar(j,i))
		if(tmp.gt.0.)then
		   istd(j,i)=sqrt(tmp/float(inbar(j,i)))
		else
		   istd(j,i)=0.
		end if
		ibar(j,i)=isum(j,i)/float(inbar(j,i))
	end if
c
	if(cnbar(j,i).ne.0)then
		tmp=csum2(j,i)-csum(j,i)*csum(j,i)/float(cnbar(j,i))
		if(tmp.gt.0.)then
		   cstd(j,i)=sqrt(tmp/float(cnbar(j,i)))
		else
		   cstd(j,i)=0.
		end if
		cbar(j,i)=csum(j,i)/float(cnbar(j,i))
	end if
c
c	type 850,i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
c	write(18,850)i,j,zbar(i),ibar(j,i),istd(j,i),cbar(j,i),cstd(j,i)
c
	end do
	end do
c
	recl=80
c
	open(unit=18,file='good.out',status='new',form='formatted',
     :  access='direct',recl=recl)
c
	do i=1,nz
c
	if(z(i).gt.0. .and. z(i).lt.2500.)then
	iz=int(z(i)/20.)+1
	zbar(iz)=iz*20.-10.
	else
	iz=126
	end if
c
	do j=1,20
c
	id1=ibar(j,iz)-4.*istd(j,iz)
	id2=ibar(j,iz)+3.*istd(j,iz)
	cd1=cbar(j,iz)-4.*cstd(j,iz)
	cd2=cbar(j,iz)+3.*cstd(j,iz)
c
cxx	if(iz.ne.0 .and. inn(j,i).lt.id2 .and. inn(j,i).gt.id1 .and.
cxx     :    cor(j,i).lt.cd2 .and. cor(j,i).gt.cd1)then
c
	gdflag(j,i)=1
cxx	else
cxx	gdflag(j,i)=0
cxx	end if
c
	end do
c
	write(unit=18,rec=i,fmt=861)(gdflag(j,i),j=1,20)
c	type 860,i,z(i),(gflag(j,i),j=1,20)
860	format(i6,f6.0,20i3)
861	format(20i3)
c
	end do
c
	close(unit=36)
	close(unit=37)
	close(unit=38)
	close(unit=39)
c
	close(unit=32)
	close(unit=33)
	close(unit=34)
	close(unit=35)
	close(unit=18)
	close(unit=31)
c
	return
	end	

