	real*4 zup(2000),uup(2000),vup(2000),zzup(2000)
	real*4 zdn(2000),udn(2000),vdn(2000),zzdn(2000)
	real*4 zavg(2000),uavg(2000),vavg(2000),zzavg(2000)
	real*4 dshx(2),dshy(2)
c
	character*80	file,cast,xlab,ylab,utitle,vtitle
	character*80	bbinf,time,loc,title
c
	type *,'Enter station number'
	read(*,*)istn
c
	write(bbinf,810)istn,istn
810	format('W1:[PHOD.24NORTH.LADCP.24N',i3.3,
     +   ']24N',i3.3,'.inf')
	open(unit=21,status='old',readonly,file=bbinf)
c
	read(21,*)
	read(21,*)j1,j2,j3,j4
	read(21,*)iy,ry
	read(21,*)ix,rx
c
	write(title,815)istn
815	format('OACES 24NORTH 1998 - LADCP STATION 24N ',
     +   i3.3,' $')
c
	write(time,811)j1,j2,j3
811	format('Start Day ',i3.3,'    Time ',i2.2,':',i2.2,' Z $')
	write(loc,812)iy,ry,ix,rx
812	format('Start Location ',i2.2,f6.2,'   ',i3.3,f6.2,' $')
c
	write(file,800)istn
800	format('W1:[PHOD.24NORTH.LADCP.24N',i3.3,
     +   ']ladcp.dn')
c
	open(unit=11,status='old',readonly,file=file)
c
	do i=1,2000
c
	read(11,*,end=10)zdn(i),idum,dum,dum,udn(i),idum,dum,dum,vdn(i)
	zzdn(i)=zdn(i)
c
	end do
c
10	numdn=i-1
c
	write(file,801)istn
801	format('W1:[PHOD.24NORTH.LADCP.24N',i3.3,
     +   ']ladcp.up')
c
	open(unit=11,status='old',readonly,file=file)
c
	do i=1,2000
c
	read(11,*,end=20)zup(i),idum,dum,dum,uup(i),idum,dum,dum,vup(i)
	zzup(i)=zup(i)
c
	end do
c	
20	numup=i-1
c
	write(file,802)istn
802	format('W1:[PHOD.24NORTH.LADCP.24N',i3.3,
     +   ']ladcp.avg')
c
	open(unit=11,status='old',readonly,file=file)
c
	do i=1,2000
c
	read(11,*,end=30)zavg(i),idum,dum,dum,uavg(i),idum,dum,dum,
     :  vavg(i)
	zzavg(i)=zavg(i)
c
	end do
c
30	numavg=i-1
c
	continue
c
	dmax=max(zdn(numdn),zup(numup),zavg(numavg))
	ndm=int(dmax/1000.)+1
	dplot=ndm*1000.
c
	xor=30
	yor=30
	xsiz=70
	ysiz=120
c
	xlab='cm/sec $'
c
	xmin=-100.
	xmax=100.
	xstep1=50.
	xstep2=10.
c
	ylab='Depth $'
c
	ymin=dplot
	ymax=0.
	ystep1=-1000.
	ystep2=-200.
	if(ymin.eq.1000.)then
	ystep1=-200.
	ystep2=-100.
	end if
	if(ymin.eq.2000.)then
	ystep1=-500.
	ystep2=-100.
	end if
c
	iticky=int(ystep1/ystep2)
	itickx=int(xstep1/xstep2)
c
	CALL groute(' ')
	call gopen
	call gsegcr(1)
c
        call gvport(xor,yor,xsiz,ysiz)
	call glimit(xmin,xmax,ymin,ymax,0.,0.)
	call gwbox(xsiz,ysiz,0.)
c
	call gcharf('SIMP')
        call gaxori(xmin,ymin)
        call gtickm(itickx)
        call gaxlab(3.,3.,0,0)
	call gaxis(1,xmin,xstep1,xmax,xlab)
        call gaxori(xmin,ymin)
	call gtickm(iticky)
        call gaxlab(3.,3.,0,0)
        call gaxis(2,ymin,ystep1,ymax,ylab)
c
        xaxdif=xmax-xmin
        yaxdif=ymax-ymin
c
        call gaxlab(3.,3.,0,0)
        call gaxori(xmin,ymax)
        call gaxend(2)
        call gaxcol(1,0,0)
        call gaxis(-1,xmin,xaxdif,xmax,'$')
        call gaxlab(3.,3.,0,0)
        call gaxori(xmax,ymin)
        call gaxend(2)
        call gaxcol(1,0,0)
        call gaxis(-2,ymin,yaxdif,ymax,'$')
c
        call gscale
c
	call gdash(6)
	call gvect(udn,zdn,numdn)
	call gdash(9)
        call gvect(uup,zup,numup)
	call gdash(0)
        call gwicol(.5,1)
        call gvect(uavg,zavg,numavg)
c
	yy=ymin
	do while (yy.gt.ymax)	
	yy=yy+ystep1
	dshy(1)=yy
	dshy(2)=yy
	dshx(1)=xmin
	dshx(2)=xmax
        call gwicol(-1.,1)
	call gdash(6)
	call gvect(dshx,dshy,2)
	end do
c
	xx=xmin
	do while (xx.lt.xmax)	
	xx=xx+xstep1
	dshy(1)=ymin
	dshy(2)=ymax
	dshx(1)=xx
	dshx(2)=xx
        call gwicol(-1.,1)
	call gdash(6)
	call gvect(dshx,dshy,2)
	end do
c
	dshx(1)=0
	dshx(2)=0
	dshy(1)=ymax
	dshy(2)=ymin
	call gvect(dshx,dshy,2)
c
	call gscamm
	write(utitle,901)
901	format(' U Velocity $')
	call gchar(utitle,xor+15.,yor+ysiz+5.,3.5)
c
	call gchar(title,xor+5.,yor+ysiz+26.,3.5)
	call gchar(time,xor+5.,yor+ysiz+19.,3.5)
	call gchar(loc,xor+5.,yor+ysiz+12.,3.5)
c
	xor=130
	yor=30
	xsiz=70
	ysiz=120
c
	call gscamm
c
	write(vtitle,902)
902	format(' V Velocity $')
	call gchar(vtitle,xor+15.,yor+ysiz+5.,3.5)
c
	xlab='cm/sec $'
c
	xmin=-200.
	xmax=200.
	xstep1=100.
	xstep2=20.
c
	ylab='Depth $'
c
	ymin=dplot
	ymax=0.
	ystep1=-1000.
	ystep2=-200.
	if(ymin.eq.1000.)then
	ystep1=-200.
	ystep2=-100.
	end if
	if(ymin.eq.2000.)then
	ystep1=-500.
	ystep2=-100.
	end if
c
	iticky=int(ystep1/ystep2)
	itickx=int(xstep1/xstep2)
c
        call gvport(xor,yor,xsiz,ysiz)
	call glimit(xmin,xmax,ymin,ymax,0.,0.)
	call gwbox(xsiz,ysiz,0.)
c
        call gaxcol(1,1,1)
	call gscale
	call gcharf('SIMP')
        call gaxori(xmin,ymin)
        call gtickm(itickx)
        call gaxlab(3.,3.,0,0)
	call gaxis(1,xmin,xstep1,xmax,xlab)
        call gaxori(xmin,ymin)
	call gtickm(iticky)
        call gaxlab(3.,3.,0,0)
        call gaxis(2,ymin,ystep1,ymax,ylab)
c
        xaxdif=xmax-xmin
        yaxdif=ymax-ymin
c
        call gaxlab(3.,3.,0,0)
        call gaxori(xmin,ymax)
        call gaxend(2)
        call gaxcol(1,0,0)
        call gaxis(-1,xmin,xaxdif,xmax,'$')
        call gaxlab(3.,3.,0,0)
        call gaxori(xmax,ymin)
        call gaxend(2)
        call gaxcol(1,0,0)
        call gaxis(-2,ymin,yaxdif,ymax,'$')
c
        call gscale
c
	call gdash(6)
	call gvect(vdn,zzdn,numdn)
	call gdash(9)
        call gvect(vup,zzup,numup)
	call gdash(0)
        call gwicol(.5,1)
        call gvect(vavg,zzavg,numavg)
c
	yy=ymin
	do while (yy.gt.ymax)	
	yy=yy+ystep1
	dshy(1)=yy
	dshy(2)=yy
	dshx(1)=xmin
	dshx(2)=xmax
        call gwicol(-1.,1)
	call gdash(6)
	call gvect(dshx,dshy,2)
	end do
c
	xx=xmin
	do while (xx.lt.xmax)	
	xx=xx+xstep1
	dshy(1)=ymin
	dshy(2)=ymax
	dshx(1)=xx
	dshx(2)=xx
        call gwicol(-1.,1)
	call gdash(6)
	call gvect(dshx,dshy,2)
	end do
c
	dshx(1)=0
	dshx(2)=0
	dshy(1)=ymax
	dshy(2)=ymin
	call gsegcl(1)
	call gvect(dshx,dshy,2)
c
	call gsegcl(1)
	call gclose
c
	stop
	end

