	integer*4 	user_pc_time_1
	integer*4 	user_gps_time_1
	real*8		user_lat_1 , user_lon_1
	real*4 		height_1
	integer*4	nsat_1,msg_type_1
c
	integer*4 	user_pc_time_2
	integer*4 	user_gps_time_2
	real*8		user_lat_2 , user_lon_2
	real*4 		height_2
	integer*4	nsat_2,msg_type_2
c
	integer*4 	user_pc_time_3
	integer*4 	user_gps_time_3
	real*8		user_lat_3 , user_lon_3
	real*4 		height_3
	integer*4	nsat_3,msg_type_3
c
	integer*4 	user_pc_time_4
	integer*4 	user_gps_time_4
	real*8		user_lat_4 , user_lon_4
	real*4 		height_4
	integer*4	nsat_4,msg_type_4
c
	integer*4		dh_mean
	integer*4		dh_std
	integer*4		dh_min
	integer*4		dh_max
c
	integer*4		p_mean
	integer*4		p_std
	integer*4		p_min
	integer*4		p_max
c
	integer*4		r_mean
	integer*4		r_std
	integer*4		r_min
	integer*4		r_max
c
	integer*4		mrms_mean
	integer*4		mrms_std
	integer*4		mrms_min
	integer*4		mrms_max
c
	integer*4		brms_mean
	integer*4		brms_std
	integer*4		brms_min
	integer*4		brms_max
c
	integer*4		n_att
	integer*4		n_used
	integer*4		n_reacq
	integer*4		n_mrms
	integer*4		n_brms
	integer*4		n_outlier
c
	integer*4 ensemble_number
c
	real*4 	rdum /-999.9/
c
	real*8	dst,az1,az2,xbar,ybar,lastday
c
	character*80 user_file
c
	type *,'Enter concatenated User_Exit file name'
c
	read(*,'(a)')user_file
c
	open(unit=12,file=user_file,status='old',readonly)
c	open(unit=13,file='user.spd',status='new',form='formatted',
c     :    recl=150)
c
	icount=0
	do while(icount.lt.500)
c
    	read(12,543,end=99)ensemble_number,id,rd,avg_heading,ub,vb
543     format(2x,i7,x,i5,x,f10.7,3f12.1)
         read(12,*)iver,inumavg,sec_add
        read(12,*)user_pc_time_1,user_gps_time_1,
     :        user_lat_1,user_lon_1,height_1,
     :        dop_1,nsat_1,msg_type_1
        read(12,*)user_pc_time_2,user_gps_time_2,
     :        user_lat_2,user_lon_2,height_2,
     :        dop_2,nsat_2,msg_type_2
        read(12,*)user_pc_time_3,user_gps_time_3,
     :        user_lat_3,user_lon_3,height_3,
     :        dop_3,nsat_3,msg_type_3
        read(12,*)user_pc_time_4,user_gps_time_4,
     :        user_lat_4,user_lon_4,height_4,
     :        dop_4,nsat_4,msg_type_4
        read(12,*)dh_mean,dh_std,dh_min,dh_max
        read(12,*)p_mean,p_std,p_min,p_max
        read(12,*)r_mean,r_std,r_min,r_max
        read(12,*)mrms_mean,mrms_std,mrms_min,mrms_max
 	read(12,*)brms_mean,brms_std,brms_min,brms_max
        read(12,*)n_att,n_used,n_reacq,n_mrms,n_brms,
     :        n_outlier
c
	call geodinv (user_lat_1,user_lon_1,user_lat_2,user_lon_2,
     :        dst,az1,az2)
	
	ybar=(user_lat_1 + user_lat_2) / 2.
	xbar=(user_lon_1 + user_lon_2) / 2.
c
	if(user_pc_time_2 .lt. user_pc_time_1)user_pc_time_2 = 
     : user_pc_time_2 + 86400
	dsec_pc=float(user_pc_time_2 - user_pc_time_1)
c
	if(user_gps_time_2 .lt. user_gps_time_1)user_gps_time_2 = 
     : user_gps_time_2 + 86400
	dsec_gps=float(user_gps_time_2 - user_gps_time_1)
c
	if(dsec_gps.ne.0)then
	spd=100.*dst/dsec_gps
	cog=az1
c
	gyro=avg_heading-45.
	if(gyro.lt.0.)gyro=gyro+360.
c
c	type *,' spd, cog ',spd,cog
c	
	dhd=(90.-cog)+.0001
	ugps=spd*cosd(dhd)
	vgps=spd*sind(dhd)
c
	else
c
	ugps=-999.9
	vgps=-999.9
c
	end if
c
	if(abs(ugps).gt. 999. .or. abs(vgps).gt. 999.)then
		ugps=rdum
		vgps=rdum
	end if
c
	if(abs(dh_mean).gt.900)then
		dh_mean=0
		n_used=0
	end if
c
	icount=icount+1
C	if(icount.le.5374)id=id+2
C	if(icount.gt.5374 .and. icount.le.7041)id=id+3
C	if(icount.gt.7041)id=id+4
c
	write(19, 899)id+rd,ub,vb,ugps,vgps,avg_heading,dh_mean,n_used
899	FORMAT(f12.5,5f10.1,2i8)
c	write(13,531)ensemble_number,id+rd,ybar,xbar,ugps,vgps,gyro,
c     :    dh_mean,n_used,user_gps_time_1,user_lat_1,user_lon_1,
c     :    user_gps_time_2,user_lat_2,user_lon_2
531	format(i6,3f12.5,3f8.1,2i6,2(i10,2f12.5))
c
	end do
c
99	stop
	end
c

	subroutine geodinv (la1,lo1,la2,lo2,dist,azf,azb)
c
c quick geodetic inverse based on NOAA NOS Tech Rep NOS 81 (J Collins)
c lat,lon are in decimal degrees with S,W negative
c dist is returned in meters, azimuths in true degrees 0-360
c
	implicit real*8 (a-m,o-z)       ! only integers are n's
c
c       a=6378206.4   !6378163.  ! alternate values
c       b=6356583.8   !6356177.  ! alternate values
	a=6378135.0   !wgs-72
	b=6356750.5   !wgs-72
c
	if(la1.eq.la2 .and. lo1.eq.lo2)then
		dist=0.
		azb=0.
		azf=0.
		return
	end if
c
	conv = 3.141592654 / 180.
	e0 = a*a - b*b          ! some eccentricities, not all of which
	e1 = e0 / (a*a)         ! are used.
	e2 = e0 / (b*b)
	e3 = e0 / (a*a + b*b)
	e4 = e0 / (a*b)
c
	lat1=la1*conv
	lon1=lo1*conv
	lat2=la2*conv
	lon2=lo2*conv
	dlon=lon2-lon1
c
	tanpsi1 =  b*b * tan(lat1) / (a*a)         ! geocentric lats
	tanpsi2 =  b*b * tan(lat2) / (a*a)
c
	psi1 = atan(tanpsi1)
	psi2 = atan(tanpsi2)
c
	azf = atan2 ( sin(dlon) ,                  !      fwd azimuth
     :        ( tanpsi2 - tanpsi1*cos(dlon) ) * cos(psi1) )
c
	azb = atan2 ( sin(-dlon) ,                 !      back azimuth
     :        ( tanpsi1 - tanpsi2*cos(-dlon) ) * cos(psi2) )
c
	theta1 = atan2(cos(azf),tanpsi1)
	theta2 = atan2(cos(azb),tanpsi2)
c
	beta0 = atan2 ( a * sqrt( tanpsi1*tanpsi1 +
     :          tanpsi2*tanpsi2 - 2.*tanpsi1*tanpsi2*
     :          cos(dlon) ) , b * sin(dlon) )
c
	bbar = b * sqrt ( 1. + e2 * cos(beta0)*cos(beta0) )
	mbar = (a*a - bbar*bbar) / (a*a + bbar*bbar)
c
	rad0 = sqrt ( .5 * (a*a+bbar*bbar) ) * ( 1. - mbar*mbar/16.)
	biga = mbar / 4. + 21.*mbar*mbar*mbar / 128.
	bigb = mbar*mbar / 64.
c
	s1=rad0*(theta1-biga*sin(2.*theta1)+bigb*sin(4.*theta1))
	s2=rad0*(theta2-biga*sin(2.*theta2)+bigb*sin(4.*theta2))
c
	dist = s1 + s2
	azf=azf/conv
	azb=azb/conv
	if(azf.lt.0.)azf=azf+360.
	if(azb.lt.0.)azb=azb+360.

	if(la1.eq.la2)then
		dist=(lo2-lo1)*cosd(la1)*110320.
	end if
c
	return
	end
c
