 	real*4 xpos(5),ypos(5),uref(5),vref(5)
	real*4 utemp(128),vtemp(128),lat,lon,xp(2),yp(2)
	real*4 uu(128,5000),vv(128,5000),ugrid(200,200),vgrid(200,200)
	integer*4 npos(5000),nvel(5000),ndr(5000),nbad(2000),npref(5)
	real*4 time(5000),x(5000),y(5000),us(5000),vs(5000)
	real*4 ahx(4),ahy(4),mmdeg
	integer*4 ngrid(200,200),nexc(6,2000),npsave(5)
	character*80 filename,badname,ptitle
	character f2(3)*10,f1(3)*10
	data f1/'ASCIL1.DAT','SOCIL1.DAT','AFCIL1.DAT'/
	data f2/'ASCIL2.DAT','SOCIL2.DAT','AFCIL2.DAT'/
c
	type *,' Enter name of averaged data file'
	accept '(a)',filename
c
	open(unit=13,file=filename,status='old',readonly,
     :     form='unformatted',access='direct')
c
	TYPE *,'Enter number of navigation types'
	accept *,nnv
c
	type *,' Enter order of preference for reference velocity:'
	type *,' 1 - GPS   2, 3 - DEEP, MID REF LAYER, 4 - TRANSIT ONLY'
	accept *,(npsave(j),j=1,4)

	type *,' enter filename of preference exceptions:'
	accept '(a)',filename
	open(unit=10,file=filename,status='old',readonly,
     :     form='formatted')
	do i=1,2000
		read(10,*,end=55)(nexc(j,i),j=1,5)
	end do
55	nep=i-1
	close (10)
c
	type *,'Enter start, stop records'
	accept *,nd1,nd2
c
48	nrec= 0
	do i=nd1,nd2
	read(13'i,err=955)atime,(ypos(j),xpos(j),uref(j),vref(j),j=1,1),
     :  nc,ib,bino,(utemp(ll),vtemp(ll),ll=1,ib)
c
	nrec=nrec+1
c
	time(nrec)=atime
	ndr(nrec)=i
c
	do j=1,ib
	uu(j,nrec)=utemp(j)
	vv(j,nrec)=vtemp(j)
	end do
c
	x(nrec)=-999.9
	y(nrec)=-999.9
	npos(nrec)=-1
c
	do j=1,4
	npref(j)=npsave(j)
	end do
c
	do ipr=1,nep
	   if(i.eq.nexc(1,ipr))then
		do j=1,4
		   npref(j)=nexc(j+1,ipr)
		end do
	   end if
	end do
c
	if(npref(1).gt.0)then
	  if(abs(xpos(npref(1))).lt.900.)then
		x(nrec)=xpos(npref(1))
		y(nrec)=ypos(npref(1))
		npos(nrec)=npref(1)
	        goto 555
	  end if
	end if
c
	if(npref(2).gt.0)then
	  if (abs(xpos(npref(2))).lt.900.)then
		x(nrec)=xpos(npref(2))
		y(nrec)=ypos(npref(2))
		npos(nrec)=npref(2)
	        goto 555
	  end if
	end if
c
	if(npref(3).gt.0)then
	  if (abs(xpos(npref(3))).lt.900.)then
		x(nrec)=xpos(npref(3))
		y(nrec)=ypos(npref(3))
		npos(nrec)=npref(3)
		goto 555
	  end if
	end if
c
	if(npref(4).gt.0)then
	  if (abs(xpos(npref(4))).lt.900.)then
		x(nrec)=xpos(npref(4))
		y(nrec)=ypos(npref(4))
		npos(nrec)=npref(4)
		goto 555
	  end if
	end if
c
555	us(nrec)=-999.9
	vs(nrec)=-999.9
	nvel(nrec)=-1
c
c	IF(Y(NREC).GT.27.)THEN
c		TYPE *,NREC,ATIME,NPREF,Y(NREC),X(NREC)
c	END IF
C
	if(npref(1).gt.0)then
	  if(abs(uref(npref(1))).lt.900.)then
		us(nrec)=uref(npref(1))
		vs(nrec)=vref(npref(1))
		nvel(nrec)=npref(1)
		goto 666
	  end if
	end if
c
	if(npref(2).gt.0)then
	  if(abs(uref(npref(2))).lt.900.)then
		us(nrec)=uref(npref(2))
		vs(nrec)=vref(npref(2))
		nvel(nrec)=npref(2)
	        goto 666
	  end if
	end if
c
	if(npref(3).gt.0)then
	  if(abs(uref(npref(3))).lt.900.)then
		us(nrec)=uref(npref(3))
		vs(nrec)=vref(npref(3))
		nvel(nrec)=npref(3)
		goto 666
	  end if
	end if
c
	if(npref(4).gt.0)then
	  if(abs(uref(npref(4))).lt.900.)then
		us(nrec)=uref(npref(4))
		vs(nrec)=vref(npref(4))
		nvel(nrec)=npref(4)
		goto 666
	  end if
	end if
c
666	if(npos(nrec).lt.0 .or. nvel(nrec).lt.0 .or.
     :        abs(uu(1,nrec)).gt.900.)then
		nrec=nrec-1
	else
		numbin=max(numbin,ib)
	end if
c
940	end do
c
955	continue
c
53	type *,'Enter min lat,lon (DDD.ddd with S,W negative)'
	accept *,rymin,rxmin
c
	type *,'Enter max lat,lon (DDD.ddd with S,W negative)'
	accept *,rymax,rxmax
c
	type *,'Enter mapping grid size (degrees)'
	accept *,dgrid
c
	nxpts = ((rxmax-rxmin)/dgrid)+1
	nypts = ((rymax-rymin)/dgrid)+1
c
	if(nxpts.gt.200 .or. nypts.gt.200) then
		type *,'Too many grid points - 200 x 200 max'
		goto 53
	end if
c
	type *,'Enter levels to plot (1 -',ib,' )'
	accept *,il1,il2

	do i=1,nrec
	latpt= nint( (y(i)-rymin)/dgrid ) + 1
	lonpt= nint( (x(i)-rxmin)/dgrid ) + 1
c
	if(latpt.gt.57)type *,i,y(i),x(i),us(i),vs(i)
c
	if(latpt.gt.0 .and. lonpt.gt.0 .and. latpt.le.nypts .and. 
     :     lonpt.le.nxpts) then
c
	do ilev=il1,il2
	   if(abs(uu(ilev,i)).lt.900.)then
		ugrid(lonpt,latpt) = ugrid(lonpt,latpt)+ (uu(ilev,i)+us(i))
		vgrid(lonpt,latpt) = vgrid(lonpt,latpt)+ (vv(ilev,i)+vs(i))
		ngrid(lonpt,latpt) = ngrid(lonpt,latpt)+ 1
	   end if
	end do
c
	end if
c
	end do
C
	type *,'Isentropic scaling: enter mm per degree lat/lon'
	accept *,mmdeg
	xlen = (rxmax-rxmin)*mmdeg
	ylen = (rymax-rymin)*mmdeg
c
	call groute (' ')
c
	call gopen
	call gsegcr(1)
c
	call gvport(20.,20.,xlen,ylen)
	call glimit(rxmin,rxmax,rymin,rymax,0.,0.)
	call gwbox(xlen,ylen,0.)
c
       itickm=4
       call gtickm(itickm)
       call gaxlab(4.,3.,0,0)
       call gwicol(-1.,1)
       call gaxis(1,rxmin,2.,rxmax,'$')
       itickm=4
       call gtickm(itickm)
       call gaxlab(4.,3.,0,0)
       call gaxis(2,rymin,2.,rymax,'$')
	call gwicol(-1.,1)
       call gaxori(rxmin,rymax)
       itickm=1
       call gaxend(2)
       call gtickm(itickm)
       call gaxlab(4.,3.,0,0)
       call gwicol(-1.,1)
       call gaxis(-1,rxmin,(rxmax-rxmin),rxmax,'$')
       call gaxori(rxmax,rymin)
       itickm=1
       call gaxend(2)
       call gtickm(itickm)
       call gaxlab(4.,3.,0,0)
       call gwicol(-1.,1)
       call gaxis(-2,rymin,(rymax-rymin),rymax,'$')
c
	type *,'Enter arrow scaling ( mm per 100 cm/sec)'
	accept *,vfac
	vfac= vfac/100.      !  arrow scaling (mm per cm/sec)
	alpha=22.5     !  half angle of arrowhead
	headsize=vfac*50.   !  perpendicular size of arrowhead (cm/sec)
c
	do i=1,nxpts
	do j=1,nypts
c
	if(ngrid(i,j).ne.0)then
		uav=ugrid(i,j)/float(ngrid(i,j))
		vav=vgrid(i,j)/float(ngrid(i,j))
		lat=20. + (j-1)*dgrid*mmdeg
	 	lon=20. + (i-1)*dgrid*mmdeg
		scx=(i-1)*dgrid+rxmin
		scy=(j-1)*dgrid+rymin
		write(19,803)scy,scx,uav,vav,ngrid(i,j)
803		format(2f10.4,2f10.1,i10)
		call gscamm
c
c		xp(1)=lon - .5 * uav * vfac        !  arrow body
c		yp(1)=lat - .5 * vav * vfac        !  centered at point
c		xp(2)=lon + .5 * uav * vfac
c		yp(2)=lat + .5 * vav * vfac
c
		xp(1)=lon                          !  arrow body
		yp(1)=lat                          !  begins at point
		xp(2)=lon +  uav * vfac
		yp(2)=lat +  vav * vfac
c
		adir=atan2d(vav,uav)                !   arrow head
		hlen=abs ( (headsize * vfac) / sind(90.-alpha))
		ahx(1)=xp(2)
		ahy(1)=yp(2)
		ahx(2)=ahx(1)+hlen*cosd(adir+180.-alpha)
		ahy(2)=ahy(1)+hlen*sind(adir+180.-alpha)
		ahx(3)=ahx(1)+hlen*cosd(adir+180.+alpha)
		ahy(3)=ahy(1)+hlen*sind(adir+180.+alpha)
		ahx(4)=xp(2)
		ahy(4)=yp(2)
		call gwicol(-1.,1)
		call gvect(ahx,ahy,4)
		call gwicol(-1.,1)
	        call gvect(xp,yp,2)
		call gwicol(-2.,1)
		call gdot (lon,lat,1)
	end if
c
	end do
	end do
c
		lat=20. + 2.*mmdeg
	 	lon=20. + 2.*mmdeg
		uav=100.
		vav=0.
		xp(1)=lon                          !  arrow body
		yp(1)=lat                     !  begins at point
		xp(2)=lon +  uav * vfac
		yp(2)=lat +  vav * vfac
c
		adir=atan2d(vav,uav)                !   arrow head
		hlen=abs ( (headsize * vfac) / sind(90.-alpha))
		ahx(1)=xp(2)
		ahy(1)=yp(2)
		ahx(2)=ahx(1)+hlen*cosd(adir+180.-alpha)
		ahy(2)=ahy(1)+hlen*sind(adir+180.-alpha)
		ahx(3)=ahx(1)+hlen*cosd(adir+180.+alpha)
		ahy(3)=ahy(1)+hlen*sind(adir+180.+alpha)
		ahx(4)=xp(2)
		ahy(4)=yp(2)
		call gwicol(-1.,1)
		call gvect(ahx,ahy,4)
		call gwicol(-1.,1)
	        call gvect(xp,yp,2)
		call gwicol(-2.,1)
	call gcharj(0)
	call gchar('100 cm/s $',20.+2*mmdeg,30.+mmdeg,2.5)
c
	type *,'Enter plot title'
	accept 808,nt2,ptitle
808	format(q,a80)
c
	ptitle(nt2+1:nt2+1)='$'
	call gcharj(0)
	call gchar(ptitle,20.,25.+ylen,4.)
c
	call gscamm
	ddg=.1
	xoff=20.
	yoff=20.
	call drwmap(xoff,yoff,rymin,rxmin,rymax,rxmax,.05,ddg,mmdeg,mmdeg,
     :             f2,f1,3)
	call gsegcl(1)
c
	call gclose
c
	stop
	end
c
c
	subroutine drwmap(x0,y0,ylt1,xlg1,ylt2,xlg2,rsl,ddg,yscl,xscl,drfil,
	1 dtfil,nfil)
c   This routine uses the CIA database to draw continental boundaries.
c   The data are in the default file, DFFIL, given in the data statement
c   below.  The files to be read have the following names:
c                           AFCILn.DAT    (Africa)
c                           ASCILn.DAT    (Asia)
c                           EUCILn.DAT    (Europe)
c                           NOCILn.DAT    (North America)
c                           SOCILn.DAT    (South America)
c   where n stands for either 1 or 2.  For each pair of files, a
c   sequential file (n=2) contains the min/max latitudes and longitudes 
c   of the records in a corresponding direct access file (n=1).  The NFIL 
c   10 character string variables, DRFIL, contain the sequential files 
c   (n=2) and the NFIL 10 character string variables, DTFIL, contain the 
c   direct access files (n=1).  YLT1 and YLT2 are the minimum and maximum 
c   latitudes and XLG1 and XLG2 are the minimum and maximum longitudes of 
c   the map to be drawn.  RSL is nominal resolution in degrees.  YSCL and 
c   XSCL are the scaling for the map in, for example, millimeters/degree.  
c   Dave Behringer 9/25/85.
	character drfil(nfil)*10,dtfil(nfil)*10,dffil*13
	dimension dir(2000,4),loc(2000),ylt(1000),xlg(1000)
	data dffil/'d6:[aomlwdb2]'/
	data ludr,ludt/9,10/
	data dpr/57.29578/
c	data dpr,ddg/57.29578,.1/
	do l=1,nfil
	  open(UNIT=ludr,DEFAULTFILE=dffil,FILE=drfil(l),TYPE='OLD',
	1   FORM='UNFORMATTED',READONLY,RECL=4)
	  iend=2820
	  kol=0
	  do i=1,iend
	    ii=i
	    read(ludr,end=10)(dir(i,j),j=1,4)
	    do j=3,4
	      dir(i,j)=-dir(i,j)
	    end do
	  end do
10	  iend=ii-1     
	  close(ludr)
	  nr=0
	  do i=1,iend
	    if (dir(i,1).le.ylt2.and.dir(i,2).ge.ylt1.and.
	1          dir(i,4).le.xlg2.and.dir(i,3).ge.xlg1) then
	      nr=nr+1
	      loc(nr)=i
	    end if
	  end do
	  open(UNIT=ludt,DEFAULTFILE=dffil,FILE=dtfil(l),TYPE='OLD',
	1   READONLY,FORM='UNFORMATTED',ACCESS='DIRECT',RECL=2001)
	  ipn=0
c		  if(ipn.eq.0)then            !
c			kol=kol+1              !
c			call gwicol(-1.,kol)   !
c		  end if                       !     wdw
	  do n=1,nr
	    lcn=loc(n)
	    read(ludt'lcn)pts,((ylt(i),xlg(i)),i=1,1000)
	    npts=pts
	    do i=1,npts
	      xmap=-dpr*xlg(i)
	      ymap=dpr*ylt(i)
	      if (n.eq.1.and.i.eq.1) then
	        xsav=xmap
	        ysav=ymap
	        xmp0=xmap
	        ymp0=ymap
	      end if
	      if (abs(xmap-xsav).gt.ddg.or.abs(ymap-ysav).gt.ddg) ipn=0
	      xsav=xmap
	      ysav=ymap
	      if (xmap.ge.xlg1.and.xmap.le.xlg2.and.ymap.ge.ylt1.
	1             and.ymap.le.ylt2) then
	        xmap=(xmap-xlg1)*xscl
	        ymap=(ymap-ylt1)*yscl
	        xy=sqrt((xmap-xmp0)**2+(ymap-ymp0)**2)
	        if (ipn.eq.0.or.i.eq.npts.or.xy.gt.rsl) then
	          xmp0=xmap
	          ymp0=ymap
c		  if(ipn.eq.0)then            !
c			kol=kol+1              !
c			call gwicol(-1.,kol)   !
c		  end if                       !     wdw
		call gwicol(.1,1)
	          x1=xmap+x0
		  y1=ymap+y0
			call gvect(x1,y1,ipn)
	          ipn=1
	        end if
	      else
	        ipn=0
	      end if
	    end do
	  end do
	  close(ludt)
	end do
	return  
	end
c
